# -*- coding: utf-8 -*-
"""
DO NOT EDIT! This file is auto-generated

Classes for Skyline Message Bus usage.
"""
from __future__ import absolute_import

# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import

# Import local libs
# pylint: disable=import-error
from niskyline.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from niskyline.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from niskyline.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from niskyline.messagebus.message_base import MessageBase
from niskyline.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from niskyline.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from niskyline.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import
# pylint: enable=import-error

if sys.version_info[0] >= 3:
    long = int  # pylint: disable=redefined-builtin,invalid-name


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes


#
# AuditTrail service
#


class AuditTypeEntry(object):
    """
    AuditTypeEntry custom data type.
    """
    def __init__(self,
                 short_name_,
                 description_):
        """
        :param short_name_: short_name
        :type short_name_: str
        :param description_: description
        :type description_: str
        """
        self.short_name = short_name_
        self.description = description_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditTypeEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeEntry`.
        :rtype: AuditTypeEntry
        """
        short_name_ = body_dict.get('shortName')
        description_ = body_dict.get('description')
        return cls(
            short_name_=short_name_,
            description_=description_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditTypeEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeEntry`.
        :rtype: AuditTypeEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditTypeEntry` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeEntry`.
        :rtype: AuditTypeEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        short_name_ = self.short_name
        description_ = self.description
        return {
            'shortName': short_name_,
            'description': description_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AuditEntry(object):
    """
    AuditEntry custom data type.
    """
    def __init__(self,
                 timestamp_,
                 subtype_,
                 originator_,
                 user_name_,
                 record_type_,
                 device_,
                 detail_,
                 int1_,
                 int2_,
                 int3_,
                 int4_,
                 str1_,
                 str2_,
                 str3_,
                 str4_):
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param subtype_: subtype
        :type subtype_: str
        :param originator_: originator
        :type originator_: str
        :param user_name_: user_name
        :type user_name_: str
        :param record_type_: record_type
        :type record_type_: str
        :param device_: device
        :type device_: str
        :param detail_: detail
        :type detail_: str
        :param int1_: int1
        :type int1_: int
        :param int2_: int2
        :type int2_: int
        :param int3_: int3
        :type int3_: int
        :param int4_: int4
        :type int4_: int
        :param str1_: str1
        :type str1_: str
        :param str2_: str2
        :type str2_: str
        :param str3_: str3
        :type str3_: str
        :param str4_: str4
        :type str4_: str
        """
        self.timestamp = timestamp_
        self.subtype = subtype_
        self.originator = originator_
        self.user_name = user_name_
        self.record_type = record_type_
        self.device = device_
        self.detail = detail_
        self.int1 = int1_
        self.int2 = int2_
        self.int3 = int3_
        self.int4 = int4_
        self.str1 = str1_
        self.str2 = str2_
        self.str3 = str3_
        self.str4 = str4_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AuditEntry`.
        :rtype: AuditEntry
        """
        timestamp_ = body_dict.get('timestamp')
        if timestamp_ is not None and not isinstance(timestamp_, datetime):
            timestamp_ = to_datetime(timestamp_)
        subtype_ = body_dict.get('subtype')
        originator_ = body_dict.get('originator')
        user_name_ = body_dict.get('userName')
        record_type_ = body_dict.get('recordType')
        device_ = body_dict.get('device')
        detail_ = body_dict.get('detail')
        int1_ = body_dict.get('int1')
        int2_ = body_dict.get('int2')
        int3_ = body_dict.get('int3')
        int4_ = body_dict.get('int4')
        str1_ = body_dict.get('str1')
        str2_ = body_dict.get('str2')
        str3_ = body_dict.get('str3')
        str4_ = body_dict.get('str4')
        return cls(
            timestamp_=timestamp_,
            subtype_=subtype_,
            originator_=originator_,
            user_name_=user_name_,
            record_type_=record_type_,
            device_=device_,
            detail_=detail_,
            int1_=int1_,
            int2_=int2_,
            int3_=int3_,
            int4_=int4_,
            str1_=str1_,
            str2_=str2_,
            str3_=str3_,
            str4_=str4_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditEntry`.
        :rtype: AuditEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditEntry` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditEntry`.
        :rtype: AuditEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_ = self.timestamp
        if timestamp_ is not None and isinstance(timestamp_, datetime):
            timestamp_ = from_datetime(timestamp_)
        subtype_ = self.subtype
        originator_ = self.originator
        user_name_ = self.user_name
        record_type_ = self.record_type
        device_ = self.device
        detail_ = self.detail
        int1_ = self.int1
        int2_ = self.int2
        int3_ = self.int3
        int4_ = self.int4
        str1_ = self.str1
        str2_ = self.str2
        str3_ = self.str3
        str4_ = self.str4
        return {
            'timestamp': timestamp_,
            'subtype': subtype_,
            'originator': originator_,
            'userName': user_name_,
            'recordType': record_type_,
            'device': device_,
            'detail': detail_,
            'int1': int1_,
            'int2': int2_,
            'int3': int3_,
            'int4': int4_,
            'str1': str1_,
            'str2': str2_,
            'str3': str3_,
            'str4': str4_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AuditQueryParameters(object):
    """
    AuditQueryParameters custom data type.
    """
    def __init__(self,
                 timestamp_from_,
                 timestamp_to_,
                 originator_,
                 record_type_,
                 subtype_,
                 device_,
                 detail_,
                 int1_,
                 int2_,
                 int3_,
                 int4_,
                 str1_,
                 str2_,
                 str3_,
                 str4_,
                 query_using_timestamps_,
                 query_using_ints_,
                 skip_count_,
                 max_records_,
                 order_by_,
                 order_by_descending_):
        """
        :param timestamp_from_: timestamp_from
        :type timestamp_from_: datetime
        :param timestamp_to_: timestamp_to
        :type timestamp_to_: datetime
        :param originator_: originator
        :type originator_: str
        :param record_type_: record_type
        :type record_type_: str
        :param subtype_: subtype
        :type subtype_: str
        :param device_: device
        :type device_: str
        :param detail_: detail
        :type detail_: str
        :param int1_: int1
        :type int1_: int
        :param int2_: int2
        :type int2_: int
        :param int3_: int3
        :type int3_: int
        :param int4_: int4
        :type int4_: int
        :param str1_: str1
        :type str1_: str
        :param str2_: str2
        :type str2_: str
        :param str3_: str3
        :type str3_: str
        :param str4_: str4
        :type str4_: str
        :param query_using_timestamps_: query_using_timestamps
        :type query_using_timestamps_: bool
        :param query_using_ints_: query_using_ints
        :type query_using_ints_: list(int)
        :param skip_count_: skip_count
        :type skip_count_: int
        :param max_records_: max_records
        :type max_records_: int
        :param order_by_: order_by
        :type order_by_: str
        :param order_by_descending_: order_by_descending
        :type order_by_descending_: str
        """
        self.timestamp_from = timestamp_from_
        self.timestamp_to = timestamp_to_
        self.originator = originator_
        self.record_type = record_type_
        self.subtype = subtype_
        self.device = device_
        self.detail = detail_
        self.int1 = int1_
        self.int2 = int2_
        self.int3 = int3_
        self.int4 = int4_
        self.str1 = str1_
        self.str2 = str2_
        self.str3 = str3_
        self.str4 = str4_
        self.query_using_timestamps = query_using_timestamps_
        self.query_using_ints = query_using_ints_
        self.skip_count = skip_count_
        self.max_records = max_records_
        self.order_by = order_by_
        self.order_by_descending = order_by_descending_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditQueryParameters` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AuditQueryParameters`.
        :rtype: AuditQueryParameters
        """
        timestamp_from_ = body_dict.get('timestampFrom')
        if timestamp_from_ is not None and not isinstance(timestamp_from_, datetime):
            timestamp_from_ = to_datetime(timestamp_from_)
        timestamp_to_ = body_dict.get('timestampTo')
        if timestamp_to_ is not None and not isinstance(timestamp_to_, datetime):
            timestamp_to_ = to_datetime(timestamp_to_)
        originator_ = body_dict.get('originator')
        record_type_ = body_dict.get('recordType')
        subtype_ = body_dict.get('subtype')
        device_ = body_dict.get('device')
        detail_ = body_dict.get('detail')
        int1_ = body_dict.get('int1')
        int2_ = body_dict.get('int2')
        int3_ = body_dict.get('int3')
        int4_ = body_dict.get('int4')
        str1_ = body_dict.get('str1')
        str2_ = body_dict.get('str2')
        str3_ = body_dict.get('str3')
        str4_ = body_dict.get('str4')
        query_using_timestamps_ = body_dict.get('queryUsingTimestamps')
        query_using_ints_ = body_dict.get('queryUsingInts')
        skip_count_ = body_dict.get('skipCount')
        max_records_ = body_dict.get('maxRecords')
        order_by_ = body_dict.get('orderBy')
        order_by_descending_ = body_dict.get('orderByDescending')
        return cls(
            timestamp_from_=timestamp_from_,
            timestamp_to_=timestamp_to_,
            originator_=originator_,
            record_type_=record_type_,
            subtype_=subtype_,
            device_=device_,
            detail_=detail_,
            int1_=int1_,
            int2_=int2_,
            int3_=int3_,
            int4_=int4_,
            str1_=str1_,
            str2_=str2_,
            str3_=str3_,
            str4_=str4_,
            query_using_timestamps_=query_using_timestamps_,
            query_using_ints_=query_using_ints_,
            skip_count_=skip_count_,
            max_records_=max_records_,
            order_by_=order_by_,
            order_by_descending_=order_by_descending_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditQueryParameters` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditQueryParameters`.
        :rtype: AuditQueryParameters
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditQueryParameters` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditQueryParameters`.
        :rtype: AuditQueryParameters
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_from_ = self.timestamp_from
        if timestamp_from_ is not None and isinstance(timestamp_from_, datetime):
            timestamp_from_ = from_datetime(timestamp_from_)
        timestamp_to_ = self.timestamp_to
        if timestamp_to_ is not None and isinstance(timestamp_to_, datetime):
            timestamp_to_ = from_datetime(timestamp_to_)
        originator_ = self.originator
        record_type_ = self.record_type
        subtype_ = self.subtype
        device_ = self.device
        detail_ = self.detail
        int1_ = self.int1
        int2_ = self.int2
        int3_ = self.int3
        int4_ = self.int4
        str1_ = self.str1
        str2_ = self.str2
        str3_ = self.str3
        str4_ = self.str4
        query_using_timestamps_ = self.query_using_timestamps
        query_using_ints_ = self.query_using_ints
        skip_count_ = self.skip_count
        max_records_ = self.max_records
        order_by_ = self.order_by
        order_by_descending_ = self.order_by_descending
        return {
            'timestampFrom': timestamp_from_,
            'timestampTo': timestamp_to_,
            'originator': originator_,
            'recordType': record_type_,
            'subtype': subtype_,
            'device': device_,
            'detail': detail_,
            'int1': int1_,
            'int2': int2_,
            'int3': int3_,
            'int4': int4_,
            'str1': str1_,
            'str2': str2_,
            'str3': str3_,
            'str4': str4_,
            'queryUsingTimestamps': query_using_timestamps_,
            'queryUsingInts': query_using_ints_,
            'skipCount': skip_count_,
            'maxRecords': max_records_,
            'orderBy': order_by_,
            'orderByDescending': order_by_descending_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AuditTypeAddRoutedMessage(RoutedMessage):
    """
    AuditTypeAddRoutedMessage JSON routed message.
    """
    def __init__(self,
                 entry_):
        """
        :param entry_: entry
        :type entry_: AuditTypeEntry
        """
        self.entry = entry_
        header = MessageHeader()
        header.set_message_name('AuditTypeAddRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditTypeAddRoutedMessage')
        header.set_routing_key(routing_key)
        super(AuditTypeAddRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditTypeAddRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeAddRoutedMessage`.
        :rtype: AuditTypeAddRoutedMessage
        """
        entry_ = body_dict.get('entry')
        if entry_ is not None:
            entry_ = AuditTypeEntry.from_dict(entry_)
        return cls(
            entry_=entry_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditTypeAddRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeAddRoutedMessage`.
        :rtype: AuditTypeAddRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditTypeAddRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeAddRoutedMessage`.
        :rtype: AuditTypeAddRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditTypeAddRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditTypeAddRoutedMessage`.
        :rtype: AuditTypeAddRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        entry_ = self.entry
        if entry_ is not None:
            entry_ = entry_.to_dict()
        return {
            'entry': entry_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditAddRoutedMessage(RoutedMessage):
    """
    AuditAddRoutedMessage JSON routed message.
    """
    def __init__(self,
                 entries_):
        """
        :param entries_: entries
        :type entries_: list(AuditEntry)
        """
        self.entries = entries_
        header = MessageHeader()
        header.set_message_name('AuditAddRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditAddRoutedMessage')
        header.set_routing_key(routing_key)
        super(AuditAddRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditAddRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditAddRoutedMessage`.
        :rtype: AuditAddRoutedMessage
        """
        entries_ = body_dict.get('entries')
        if entries_ is not None:
            new_list = []
            for item in entries_:
                item = AuditEntry.from_dict(item)
                new_list.append(item)
            entries_ = new_list
        return cls(
            entries_=entries_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditAddRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditAddRoutedMessage`.
        :rtype: AuditAddRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditAddRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditAddRoutedMessage`.
        :rtype: AuditAddRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditAddRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditAddRoutedMessage`.
        :rtype: AuditAddRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        entries_ = self.entries
        if entries_ is not None:
            new_list = []
            for item in entries_:
                new_list.append(item.to_dict())
            entries_ = new_list
        return {
            'entries': entries_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditDeleteRoutedMessage(RoutedMessage):
    """
    AuditDeleteRoutedMessage JSON routed message.
    """
    def __init__(self,
                 id_):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.set_message_name('AuditDeleteRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditDeleteRoutedMessage')
        header.set_routing_key(routing_key)
        super(AuditDeleteRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditDeleteRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditDeleteRoutedMessage`.
        :rtype: AuditDeleteRoutedMessage
        """
        id_ = body_dict.get('id')
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditDeleteRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditDeleteRoutedMessage`.
        :rtype: AuditDeleteRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditDeleteRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditDeleteRoutedMessage`.
        :rtype: AuditDeleteRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditDeleteRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditDeleteRoutedMessage`.
        :rtype: AuditDeleteRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditTypeListRequest(RequestMessage):
    """
    AuditTypeListRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('AuditTypeListRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditTypeListRequest')
        header.set_routing_key(routing_key)
        super(AuditTypeListRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`AuditTypeListRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeListRequest`.
        :rtype: AuditTypeListRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditTypeListRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeListRequest`.
        :rtype: AuditTypeListRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditTypeListRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeListRequest`.
        :rtype: AuditTypeListRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditTypeListRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditTypeListRequest`.
        :rtype: AuditTypeListRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditTypeListResponse(ResponseMessage):
    """
    AuditTypeListResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 entries_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param entries_: entries
        :type entries_: list(AuditTypeEntry)
        """
        self.entries = entries_
        header = MessageHeader()
        header.set_message_name('AuditTypeListResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'AuditTypeListResponse')
            header.set_routing_key(routing_key)
        super(AuditTypeListResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`AuditTypeListResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeListResponse`.
        :rtype: AuditTypeListResponse
        """
        entries_ = body_dict.get('entries')
        if entries_ is not None:
            new_list = []
            for item in entries_:
                item = AuditTypeEntry.from_dict(item)
                new_list.append(item)
            entries_ = new_list
        return cls(
            request_message,
            entries_=entries_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`AuditTypeListResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeListResponse`.
        :rtype: AuditTypeListResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`AuditTypeListResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeListResponse`.
        :rtype: AuditTypeListResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditTypeListResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditTypeListResponse`.
        :rtype: AuditTypeListResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'AuditTypeListResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        entries_ = self.entries
        if entries_ is not None:
            new_list = []
            for item in entries_:
                new_list.append(item.to_dict())
            entries_ = new_list
        return {
            'entries': entries_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'AuditTypeListResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditTypeDeleteRequest(RequestMessage):
    """
    AuditTypeDeleteRequest JSON request message.
    """
    def __init__(self,
                 id_):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.set_message_name('AuditTypeDeleteRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditTypeDeleteRequest')
        header.set_routing_key(routing_key)
        super(AuditTypeDeleteRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditTypeDeleteRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeDeleteRequest`.
        :rtype: AuditTypeDeleteRequest
        """
        id_ = body_dict.get('id')
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditTypeDeleteRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeDeleteRequest`.
        :rtype: AuditTypeDeleteRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditTypeDeleteRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeDeleteRequest`.
        :rtype: AuditTypeDeleteRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditTypeDeleteRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditTypeDeleteRequest`.
        :rtype: AuditTypeDeleteRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditTypeDeleteResponse(ResponseMessage):
    """
    AuditTypeDeleteResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('AuditTypeDeleteResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'AuditTypeDeleteResponse')
            header.set_routing_key(routing_key)
        super(AuditTypeDeleteResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`AuditTypeDeleteResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditTypeDeleteResponse`.
        :rtype: AuditTypeDeleteResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`AuditTypeDeleteResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditTypeDeleteResponse`.
        :rtype: AuditTypeDeleteResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`AuditTypeDeleteResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditTypeDeleteResponse`.
        :rtype: AuditTypeDeleteResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditTypeDeleteResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditTypeDeleteResponse`.
        :rtype: AuditTypeDeleteResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'AuditTypeDeleteResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'AuditTypeDeleteResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditQueryRequest(RequestMessage):
    """
    AuditQueryRequest JSON request message.
    """
    def __init__(self,
                 parameters_,
                 take_count_,
                 skip_count_):
        """
        :param parameters_: parameters
        :type parameters_: AuditQueryParameters
        :param take_count_: take_count
        :type take_count_: int
        :param skip_count_: skip_count
        :type skip_count_: int
        """
        self.parameters = parameters_
        self.take_count = take_count_
        self.skip_count = skip_count_
        header = MessageHeader()
        header.set_message_name('AuditQueryRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('AuditTrail', 'AuditQueryRequest')
        header.set_routing_key(routing_key)
        super(AuditQueryRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AuditQueryRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditQueryRequest`.
        :rtype: AuditQueryRequest
        """
        parameters_ = body_dict.get('parameters')
        if parameters_ is not None:
            parameters_ = AuditQueryParameters.from_dict(parameters_)
        take_count_ = body_dict.get('takeCount')
        skip_count_ = body_dict.get('skipCount')
        return cls(
            parameters_=parameters_,
            take_count_=take_count_,
            skip_count_=skip_count_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AuditQueryRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditQueryRequest`.
        :rtype: AuditQueryRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AuditQueryRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditQueryRequest`.
        :rtype: AuditQueryRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditQueryRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditQueryRequest`.
        :rtype: AuditQueryRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        parameters_ = self.parameters
        if parameters_ is not None:
            parameters_ = parameters_.to_dict()
        take_count_ = self.take_count
        skip_count_ = self.skip_count
        return {
            'parameters': parameters_,
            'takeCount': take_count_,
            'skipCount': skip_count_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AuditQueryResponse(ResponseMessage):
    """
    AuditQueryResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 entries_,
                 full_count_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param entries_: entries
        :type entries_: list(AuditEntry)
        :param full_count_: full_count
        :type full_count_: int
        """
        self.entries = entries_
        self.full_count = full_count_
        header = MessageHeader()
        header.set_message_name('AuditQueryResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'AuditQueryResponse')
            header.set_routing_key(routing_key)
        super(AuditQueryResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`AuditQueryResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AuditQueryResponse`.
        :rtype: AuditQueryResponse
        """
        entries_ = body_dict.get('entries')
        if entries_ is not None:
            new_list = []
            for item in entries_:
                item = AuditEntry.from_dict(item)
                new_list.append(item)
            entries_ = new_list
        full_count_ = body_dict.get('fullCount')
        return cls(
            request_message,
            entries_=entries_,
            full_count_=full_count_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`AuditQueryResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AuditQueryResponse`.
        :rtype: AuditQueryResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`AuditQueryResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AuditQueryResponse`.
        :rtype: AuditQueryResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AuditQueryResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`AuditQueryResponse`.
        :rtype: AuditQueryResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'AuditQueryResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        entries_ = self.entries
        if entries_ is not None:
            new_list = []
            for item in entries_:
                new_list.append(item.to_dict())
            entries_ = new_list
        full_count_ = self.full_count
        return {
            'entries': entries_,
            'fullCount': full_count_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'AuditQueryResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body
