# -*- coding: utf-8 -*-
"""
DO NOT EDIT! This file is auto-generated

Classes for Skyline Message Bus usage.
"""
from __future__ import absolute_import

# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import

# Import local libs
# pylint: disable=import-error
from niskyline.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from niskyline.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from niskyline.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from niskyline.messagebus.message_base import MessageBase
from niskyline.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from niskyline.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from niskyline.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import
# pylint: enable=import-error

if sys.version_info[0] >= 3:
    long = int  # pylint: disable=redefined-builtin,invalid-name


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes


#
# MessageObjects namespace
#


class ServiceState(object):  # pylint: disable=too-few-public-methods
    """
    ServiceState normal enum.
    """
    UNKNOWN = 0
    DISABLED = 1
    MANUAL = 2
    AWAITING_DEPS = 3
    STARTING = 4
    REGISTERED = 5
    IDLE = 6
    LIVE = 7
    ERROR = 8
    UNRESPONSIVE = 9
    DEAD = 10
    SHUTTING_DOWN = 11
    STOPPED = 12
    _INT_TO_STRING = {
        0: 'UNKNOWN',
        1: 'DISABLED',
        2: 'MANUAL',
        3: 'AWAITING_DEPS',
        4: 'STARTING',
        5: 'REGISTERED',
        6: 'IDLE',
        7: 'LIVE',
        8: 'ERROR',
        9: 'UNRESPONSIVE',
        10: 'DEAD',
        11: 'SHUTTING_DOWN',
        12: 'STOPPED'
    }
    _STRING_TO_INT = {
        'UNKNOWN': 0,
        'DISABLED': 1,
        'MANUAL': 2,
        'AWAITING_DEPS': 3,
        'STARTING': 4,
        'REGISTERED': 5,
        'IDLE': 6,
        'LIVE': 7,
        'ERROR': 8,
        'UNRESPONSIVE': 9,
        'DEAD': 10,
        'SHUTTING_DOWN': 11,
        'STOPPED': 12
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`ServiceState` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`ServiceState`.
        :rtype: ServiceState
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class ServiceStartType(object):  # pylint: disable=too-few-public-methods
    """
    ServiceStartType normal enum.
    """
    SKYLINE_SERVICE = 0
    EXECUTABLE = 1
    _INT_TO_STRING = {
        0: 'SKYLINE_SERVICE',
        1: 'EXECUTABLE'
    }
    _STRING_TO_INT = {
        'SKYLINE_SERVICE': 0,
        'EXECUTABLE': 1
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`ServiceStartType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`ServiceStartType`.
        :rtype: ServiceStartType
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class ServiceStartMode(object):  # pylint: disable=too-few-public-methods
    """
    ServiceStartMode normal enum.
    """
    UNKNOWN = 0
    DISABLED = 1
    AUTO = 2
    MANUAL = 3
    _INT_TO_STRING = {
        0: 'UNKNOWN',
        1: 'DISABLED',
        2: 'AUTO',
        3: 'MANUAL'
    }
    _STRING_TO_INT = {
        'UNKNOWN': 0,
        'DISABLED': 1,
        'AUTO': 2,
        'MANUAL': 3
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`ServiceStartMode` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`ServiceStartMode`.
        :rtype: ServiceStartMode
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class SkylineExeProperties(object):  # pylint: disable=too-few-public-methods
    """
    SkylineExeProperties normal enum.
    """
    PATH = 0
    ARGUMENTS = 1
    _INT_TO_STRING = {
        0: 'PATH',
        1: 'ARGUMENTS'
    }
    _STRING_TO_INT = {
        'PATH': 0,
        'ARGUMENTS': 1
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`SkylineExeProperties` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`SkylineExeProperties`.
        :rtype: SkylineExeProperties
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class LaunchState(object):  # pylint: disable=too-few-public-methods
    """
    LaunchState normal enum.
    """
    DISABLED = 0
    AWAIT_REGISTRATION = 1
    AWAITING_DEPENDENCIES = 2
    READY_TO_LAUNCH = 3
    REGISTERED = 4
    LAUNCHING = 5
    ATTACHING = 6
    RUNNING = 7
    FAILED = 8
    _INT_TO_STRING = {
        0: 'DISABLED',
        1: 'AWAIT_REGISTRATION',
        2: 'AWAITING_DEPENDENCIES',
        3: 'READY_TO_LAUNCH',
        4: 'REGISTERED',
        5: 'LAUNCHING',
        6: 'ATTACHING',
        7: 'RUNNING',
        8: 'FAILED'
    }
    _STRING_TO_INT = {
        'DISABLED': 0,
        'AWAIT_REGISTRATION': 1,
        'AWAITING_DEPENDENCIES': 2,
        'READY_TO_LAUNCH': 3,
        'REGISTERED': 4,
        'LAUNCHING': 5,
        'ATTACHING': 6,
        'RUNNING': 7,
        'FAILED': 8
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`LaunchState` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`LaunchState`.
        :rtype: LaunchState
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


#
# Service service
#


class ServiceGoLiveRoutedMessage(RoutedMessage):
    """
    ServiceGoLiveRoutedMessage JSON routed message.
    """
    def __init__(self,
                 send_to,
                 service_guid_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param service_guid_: service_guid
        :type service_guid_: str
        """
        self.service_guid = service_guid_
        header = MessageHeader()
        header.set_message_name('ServiceGoLiveRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceGoLiveRoutedMessage')
        header.set_routing_key(routing_key)
        super(ServiceGoLiveRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`ServiceGoLiveRoutedMessage` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceGoLiveRoutedMessage`.
        :rtype: ServiceGoLiveRoutedMessage
        """
        service_guid_ = body_dict.get('serviceGuid')
        return cls(
            send_to,
            service_guid_=service_guid_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`ServiceGoLiveRoutedMessage` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceGoLiveRoutedMessage`.
        :rtype: ServiceGoLiveRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`ServiceGoLiveRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceGoLiveRoutedMessage`.
        :rtype: ServiceGoLiveRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`ServiceGoLiveRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`ServiceGoLiveRoutedMessage`.
        :rtype: ServiceGoLiveRoutedMessage
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_guid_ = self.service_guid
        return {
            'serviceGuid': service_guid_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceGoLiveRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class ServiceMakeIdleRoutedMessage(RoutedMessage):
    """
    ServiceMakeIdleRoutedMessage JSON routed message.
    """
    def __init__(self,
                 send_to):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        """
        header = MessageHeader()
        header.set_message_name('ServiceMakeIdleRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceMakeIdleRoutedMessage')
        header.set_routing_key(routing_key)
        super(ServiceMakeIdleRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`ServiceMakeIdleRoutedMessage` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceMakeIdleRoutedMessage`.
        :rtype: ServiceMakeIdleRoutedMessage
        """
        return cls(
            send_to
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`ServiceMakeIdleRoutedMessage` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceMakeIdleRoutedMessage`.
        :rtype: ServiceMakeIdleRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`ServiceMakeIdleRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceMakeIdleRoutedMessage`.
        :rtype: ServiceMakeIdleRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`ServiceMakeIdleRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`ServiceMakeIdleRoutedMessage`.
        :rtype: ServiceMakeIdleRoutedMessage
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceMakeIdleRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class ServiceShutdownRoutedMessage(RoutedMessage):
    """
    ServiceShutdownRoutedMessage JSON routed message.
    """
    def __init__(self,
                 send_to):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        """
        header = MessageHeader()
        header.set_message_name('ServiceShutdownRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceShutdownRoutedMessage')
        header.set_routing_key(routing_key)
        super(ServiceShutdownRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`ServiceShutdownRoutedMessage` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceShutdownRoutedMessage`.
        :rtype: ServiceShutdownRoutedMessage
        """
        return cls(
            send_to
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`ServiceShutdownRoutedMessage` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceShutdownRoutedMessage`.
        :rtype: ServiceShutdownRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`ServiceShutdownRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceShutdownRoutedMessage`.
        :rtype: ServiceShutdownRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`ServiceShutdownRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`ServiceShutdownRoutedMessage`.
        :rtype: ServiceShutdownRoutedMessage
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'ServiceShutdownRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class ServiceStartedBroadcast(BroadcastMessage):
    """
    ServiceStartedBroadcast JSON broadcast message.
    """
    def __init__(self,
                 service_,
                 service_reply_to_):
        """
        :param service_: service
        :type service_: str
        :param service_reply_to_: service_reply_to
        :type service_reply_to_: str
        """
        self.service = service_
        self.service_reply_to = service_reply_to_
        header = MessageHeader()
        header.set_message_name('ServiceStartedBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'ServiceStartedBroadcast')
        header.set_routing_key(routing_key)
        super(ServiceStartedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ServiceStartedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceStartedBroadcast`.
        :rtype: ServiceStartedBroadcast
        """
        service_ = body_dict.get('service')
        service_reply_to_ = body_dict.get('serviceReplyTo')
        return cls(
            service_=service_,
            service_reply_to_=service_reply_to_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ServiceStartedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceStartedBroadcast`.
        :rtype: ServiceStartedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ServiceStartedBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceStartedBroadcast`.
        :rtype: ServiceStartedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`ServiceStartedBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`ServiceStartedBroadcast`.
        :rtype: ServiceStartedBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_ = self.service
        service_reply_to_ = self.service_reply_to
        return {
            'service': service_,
            'serviceReplyTo': service_reply_to_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class ServiceStatusBroadcast(BroadcastMessage):
    """
    ServiceStatusBroadcast JSON broadcast message.
    """
    def __init__(self,
                 node_name_,
                 service_guid_,
                 service_name_,
                 service_group_name_,
                 service_reply_to_,
                 service_state_):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param service_guid_: service_guid
        :type service_guid_: str
        :param service_name_: service_name
        :type service_name_: str
        :param service_group_name_: service_group_name
        :type service_group_name_: str
        :param service_reply_to_: service_reply_to
        :type service_reply_to_: str
        :param service_state_: service_state
        :type service_state_: ServiceState
        """
        self.node_name = node_name_
        self.service_guid = service_guid_
        self.service_name = service_name_
        self.service_group_name = service_group_name_
        self.service_reply_to = service_reply_to_
        self.service_state = service_state_
        header = MessageHeader()
        header.set_message_name('ServiceStatusBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'ServiceStatusBroadcast')
        header.set_routing_key(routing_key)
        super(ServiceStatusBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ServiceStatusBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceStatusBroadcast`.
        :rtype: ServiceStatusBroadcast
        """
        node_name_ = body_dict.get('nodeName')
        service_guid_ = body_dict.get('serviceGuid')
        service_name_ = body_dict.get('serviceName')
        service_group_name_ = body_dict.get('serviceGroupName')
        service_reply_to_ = body_dict.get('serviceReplyTo')
        service_state_ = body_dict.get('serviceState')
        if service_state_ is not None:
            if isinstance(service_state_, str):
                service_state_ = ServiceState.from_string(service_state_)
            elif isinstance(service_state_, int):
                service_state_ = ServiceState(service_state_)
        return cls(
            node_name_=node_name_,
            service_guid_=service_guid_,
            service_name_=service_name_,
            service_group_name_=service_group_name_,
            service_reply_to_=service_reply_to_,
            service_state_=service_state_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ServiceStatusBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceStatusBroadcast`.
        :rtype: ServiceStatusBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ServiceStatusBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceStatusBroadcast`.
        :rtype: ServiceStatusBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`ServiceStatusBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`ServiceStatusBroadcast`.
        :rtype: ServiceStatusBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        service_guid_ = self.service_guid
        service_name_ = self.service_name
        service_group_name_ = self.service_group_name
        service_reply_to_ = self.service_reply_to
        service_state_ = self.service_state
        if service_state_ is not None:
            service_state_ = service_state_.to_string()
        return {
            'nodeName': node_name_,
            'serviceGuid': service_guid_,
            'serviceName': service_name_,
            'serviceGroupName': service_group_name_,
            'serviceReplyTo': service_reply_to_,
            'serviceState': service_state_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# ServiceManager service
#


class NodeStatus(object):  # pylint: disable=too-few-public-methods
    """
    NodeStatus normal enum.
    """
    UP_NORMAL = 0
    MISSED_HEARTBEAT = 1
    DEAD = 2
    _INT_TO_STRING = {
        0: 'UP_NORMAL',
        1: 'MISSED_HEARTBEAT',
        2: 'DEAD'
    }
    _STRING_TO_INT = {
        'UP_NORMAL': 0,
        'MISSED_HEARTBEAT': 1,
        'DEAD': 2
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`NodeStatus` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`NodeStatus`.
        :rtype: NodeStatus
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class DependencyBase(object):
    """
    DependencyBase custom data type.
    """
    def __init__(self,
                 name_,
                 version_,
                 on_same_node_):
        """
        :param name_: name
        :type name_: str
        :param version_: version
        :type version_: str
        :param on_same_node_: on_same_node
        :type on_same_node_: bool
        """
        self.name = name_
        self.version = version_
        self.on_same_node = on_same_node_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`DependencyBase` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`DependencyBase`.
        :rtype: DependencyBase
        """
        name_ = body_dict.get('name')
        version_ = body_dict.get('version')
        on_same_node_ = body_dict.get('onSameNode')
        return cls(
            name_=name_,
            version_=version_,
            on_same_node_=on_same_node_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`DependencyBase` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`DependencyBase`.
        :rtype: DependencyBase
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`DependencyBase` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`DependencyBase`.
        :rtype: DependencyBase
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = self.name
        version_ = self.version
        on_same_node_ = self.on_same_node
        return {
            'name': name_,
            'version': version_,
            'onSameNode': on_same_node_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ServiceGroup(object):
    """
    ServiceGroup custom data type.
    """
    def __init__(self,
                 name_,
                 singleton_,
                 default_instance_count_,
                 start_mode_,
                 environment_variables_,
                 properties_):
        """
        :param name_: name
        :type name_: str
        :param singleton_: singleton
        :type singleton_: bool
        :param default_instance_count_: default_instance_count
        :type default_instance_count_: int
        :param start_mode_: start_mode
        :type start_mode_: ServiceStartMode
        :param environment_variables_: environment_variables
        :type environment_variables_: dict(str, str)
        :param properties_: properties
        :type properties_: dict(str, str)
        """
        self.name = name_
        self.singleton = singleton_
        self.default_instance_count = default_instance_count_
        self.start_mode = start_mode_
        self.environment_variables = environment_variables_
        self.properties = properties_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ServiceGroup` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceGroup`.
        :rtype: ServiceGroup
        """
        name_ = body_dict.get('name')
        singleton_ = body_dict.get('singleton')
        default_instance_count_ = body_dict.get('defaultInstanceCount')
        start_mode_ = body_dict.get('startMode')
        if start_mode_ is not None:
            if isinstance(start_mode_, str):
                start_mode_ = ServiceStartMode.from_string(start_mode_)
            elif isinstance(start_mode_, int):
                start_mode_ = ServiceStartMode(start_mode_)
        environment_variables_ = body_dict.get('environmentVariables')
        properties_ = body_dict.get('properties')
        return cls(
            name_=name_,
            singleton_=singleton_,
            default_instance_count_=default_instance_count_,
            start_mode_=start_mode_,
            environment_variables_=environment_variables_,
            properties_=properties_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ServiceGroup` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceGroup`.
        :rtype: ServiceGroup
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ServiceGroup` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceGroup`.
        :rtype: ServiceGroup
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = self.name
        singleton_ = self.singleton
        default_instance_count_ = self.default_instance_count
        start_mode_ = self.start_mode
        if start_mode_ is not None:
            start_mode_ = start_mode_.to_string()
        environment_variables_ = self.environment_variables
        properties_ = self.properties
        return {
            'name': name_,
            'singleton': singleton_,
            'defaultInstanceCount': default_instance_count_,
            'startMode': start_mode_,
            'environmentVariables': environment_variables_,
            'properties': properties_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ServiceDescriptor(object):
    """
    ServiceDescriptor custom data type.
    """
    def __init__(self,
                 name_,
                 version_,
                 start_type_,
                 depends_on_,
                 service_groups_):
        """
        :param name_: name
        :type name_: str
        :param version_: version
        :type version_: str
        :param start_type_: start_type
        :type start_type_: ServiceStartType
        :param depends_on_: depends_on
        :type depends_on_: list(DependencyBase)
        :param service_groups_: service_groups
        :type service_groups_: list(ServiceGroup)
        """
        self.name = name_
        self.version = version_
        self.start_type = start_type_
        self.depends_on = depends_on_
        self.service_groups = service_groups_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ServiceDescriptor` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceDescriptor`.
        :rtype: ServiceDescriptor
        """
        name_ = body_dict.get('name')
        version_ = body_dict.get('version')
        start_type_ = body_dict.get('startType')
        if start_type_ is not None:
            if isinstance(start_type_, str):
                start_type_ = ServiceStartType.from_string(start_type_)
            elif isinstance(start_type_, int):
                start_type_ = ServiceStartType(start_type_)
        depends_on_ = body_dict.get('dependsOn')
        if depends_on_ is not None:
            new_list = []
            for item in depends_on_:
                item = DependencyBase.from_dict(item)
                new_list.append(item)
            depends_on_ = new_list
        service_groups_ = body_dict.get('serviceGroups')
        if service_groups_ is not None:
            new_list = []
            for item in service_groups_:
                item = ServiceGroup.from_dict(item)
                new_list.append(item)
            service_groups_ = new_list
        return cls(
            name_=name_,
            version_=version_,
            start_type_=start_type_,
            depends_on_=depends_on_,
            service_groups_=service_groups_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ServiceDescriptor` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceDescriptor`.
        :rtype: ServiceDescriptor
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ServiceDescriptor` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceDescriptor`.
        :rtype: ServiceDescriptor
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = self.name
        version_ = self.version
        start_type_ = self.start_type
        if start_type_ is not None:
            start_type_ = start_type_.to_string()
        depends_on_ = self.depends_on
        if depends_on_ is not None:
            new_list = []
            for item in depends_on_:
                new_list.append(item.to_dict())
            depends_on_ = new_list
        service_groups_ = self.service_groups
        if service_groups_ is not None:
            new_list = []
            for item in service_groups_:
                new_list.append(item.to_dict())
            service_groups_ = new_list
        return {
            'name': name_,
            'version': version_,
            'startType': start_type_,
            'dependsOn': depends_on_,
            'serviceGroups': service_groups_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ServiceInstanceBase(object):
    """
    ServiceInstanceBase custom data type.
    """
    def __init__(self,
                 service_guid_,
                 name_,
                 version_,
                 node_name_,
                 service_group_name_,
                 service_state_,
                 reply_to_queue_,
                 service_descriptor_,
                 launch_time_,
                 stop_time_,
                 process_id_):
        """
        :param service_guid_: service_guid
        :type service_guid_: str
        :param name_: name
        :type name_: str
        :param version_: version
        :type version_: str
        :param node_name_: node_name
        :type node_name_: str
        :param service_group_name_: service_group_name
        :type service_group_name_: str
        :param service_state_: service_state
        :type service_state_: ServiceState
        :param reply_to_queue_: reply_to_queue
        :type reply_to_queue_: str
        :param service_descriptor_: service_descriptor
        :type service_descriptor_: ServiceDescriptor
        :param launch_time_: launch_time
        :type launch_time_: datetime
        :param stop_time_: stop_time
        :type stop_time_: datetime
        :param process_id_: process_id
        :type process_id_: int
        """
        self.service_guid = service_guid_
        self.name = name_
        self.version = version_
        self.node_name = node_name_
        self.service_group_name = service_group_name_
        self.service_state = service_state_
        self.reply_to_queue = reply_to_queue_
        self.service_descriptor = service_descriptor_
        self.launch_time = launch_time_
        self.stop_time = stop_time_
        self.process_id = process_id_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ServiceInstanceBase` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ServiceInstanceBase`.
        :rtype: ServiceInstanceBase
        """
        service_guid_ = body_dict.get('serviceGuid')
        name_ = body_dict.get('name')
        version_ = body_dict.get('version')
        node_name_ = body_dict.get('nodeName')
        service_group_name_ = body_dict.get('serviceGroupName')
        service_state_ = body_dict.get('serviceState')
        if service_state_ is not None:
            if isinstance(service_state_, str):
                service_state_ = ServiceState.from_string(service_state_)
            elif isinstance(service_state_, int):
                service_state_ = ServiceState(service_state_)
        reply_to_queue_ = body_dict.get('replyToQueue')
        service_descriptor_ = body_dict.get('serviceDescriptor')
        if service_descriptor_ is not None:
            service_descriptor_ = ServiceDescriptor.from_dict(service_descriptor_)
        launch_time_ = body_dict.get('launchTime')
        if launch_time_ is not None and not isinstance(launch_time_, datetime):
            launch_time_ = to_datetime(launch_time_)
        stop_time_ = body_dict.get('stopTime')
        if stop_time_ is not None and not isinstance(stop_time_, datetime):
            stop_time_ = to_datetime(stop_time_)
        process_id_ = body_dict.get('processId')
        return cls(
            service_guid_=service_guid_,
            name_=name_,
            version_=version_,
            node_name_=node_name_,
            service_group_name_=service_group_name_,
            service_state_=service_state_,
            reply_to_queue_=reply_to_queue_,
            service_descriptor_=service_descriptor_,
            launch_time_=launch_time_,
            stop_time_=stop_time_,
            process_id_=process_id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ServiceInstanceBase` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ServiceInstanceBase`.
        :rtype: ServiceInstanceBase
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ServiceInstanceBase` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ServiceInstanceBase`.
        :rtype: ServiceInstanceBase
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_guid_ = self.service_guid
        name_ = self.name
        version_ = self.version
        node_name_ = self.node_name
        service_group_name_ = self.service_group_name
        service_state_ = self.service_state
        if service_state_ is not None:
            service_state_ = service_state_.to_string()
        reply_to_queue_ = self.reply_to_queue
        service_descriptor_ = self.service_descriptor
        if service_descriptor_ is not None:
            service_descriptor_ = service_descriptor_.to_dict()
        launch_time_ = self.launch_time
        if launch_time_ is not None and isinstance(launch_time_, datetime):
            launch_time_ = from_datetime(launch_time_)
        stop_time_ = self.stop_time
        if stop_time_ is not None and isinstance(stop_time_, datetime):
            stop_time_ = from_datetime(stop_time_)
        process_id_ = self.process_id
        return {
            'serviceGuid': service_guid_,
            'name': name_,
            'version': version_,
            'nodeName': node_name_,
            'serviceGroupName': service_group_name_,
            'serviceState': service_state_,
            'replyToQueue': reply_to_queue_,
            'serviceDescriptor': service_descriptor_,
            'launchTime': launch_time_,
            'stopTime': stop_time_,
            'processId': process_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class NodeStatusRecord(object):
    """
    NodeStatusRecord custom data type.
    """
    def __init__(self,
                 node_name_,
                 status_,
                 last_heartbeat_time_):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param status_: status
        :type status_: NodeStatus
        :param last_heartbeat_time_: last_heartbeat_time
        :type last_heartbeat_time_: datetime
        """
        self.node_name = node_name_
        self.status = status_
        self.last_heartbeat_time = last_heartbeat_time_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`NodeStatusRecord` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeStatusRecord`.
        :rtype: NodeStatusRecord
        """
        node_name_ = body_dict.get('nodeName')
        status_ = body_dict.get('status')
        if status_ is not None:
            if isinstance(status_, str):
                status_ = NodeStatus.from_string(status_)
            elif isinstance(status_, int):
                status_ = NodeStatus(status_)
        last_heartbeat_time_ = body_dict.get('lastHeartbeatTime')
        if last_heartbeat_time_ is not None and not isinstance(last_heartbeat_time_, datetime):
            last_heartbeat_time_ = to_datetime(last_heartbeat_time_)
        return cls(
            node_name_=node_name_,
            status_=status_,
            last_heartbeat_time_=last_heartbeat_time_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`NodeStatusRecord` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeStatusRecord`.
        :rtype: NodeStatusRecord
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`NodeStatusRecord` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`NodeStatusRecord`.
        :rtype: NodeStatusRecord
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        status_ = self.status
        if status_ is not None:
            status_ = status_.to_string()
        last_heartbeat_time_ = self.last_heartbeat_time
        if last_heartbeat_time_ is not None and isinstance(last_heartbeat_time_, datetime):
            last_heartbeat_time_ = from_datetime(last_heartbeat_time_)
        return {
            'nodeName': node_name_,
            'status': status_,
            'lastHeartbeatTime': last_heartbeat_time_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SvcMgrHeartbeatBroadcast(BroadcastMessage):
    """
    SvcMgrHeartbeatBroadcast JSON broadcast message.
    """
    def __init__(self,
                 node_name_):
        """
        :param node_name_: node_name
        :type node_name_: str
        """
        self.node_name = node_name_
        header = MessageHeader()
        header.set_message_name('SvcMgrHeartbeatBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrHeartbeatBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrHeartbeatBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrHeartbeatBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrHeartbeatBroadcast`.
        :rtype: SvcMgrHeartbeatBroadcast
        """
        node_name_ = body_dict.get('nodeName')
        return cls(
            node_name_=node_name_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrHeartbeatBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrHeartbeatBroadcast`.
        :rtype: SvcMgrHeartbeatBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrHeartbeatBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrHeartbeatBroadcast`.
        :rtype: SvcMgrHeartbeatBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrHeartbeatBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrHeartbeatBroadcast`.
        :rtype: SvcMgrHeartbeatBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        return {
            'nodeName': node_name_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrRegisterLocalServiceRoutedMessage(RoutedMessage):
    """
    SvcMgrRegisterLocalServiceRoutedMessage JSON routed message.
    """
    def __init__(self,
                 send_to,
                 service_guid_,
                 node_name_,
                 service_name_,
                 service_group_name_,
                 reply_to_queue_,
                 process_id_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param service_guid_: service_guid
        :type service_guid_: str
        :param node_name_: node_name
        :type node_name_: str
        :param service_name_: service_name
        :type service_name_: str
        :param service_group_name_: service_group_name
        :type service_group_name_: str
        :param reply_to_queue_: reply_to_queue
        :type reply_to_queue_: str
        :param process_id_: process_id
        :type process_id_: int
        """
        self.service_guid = service_guid_
        self.node_name = node_name_
        self.service_name = service_name_
        self.service_group_name = service_group_name_
        self.reply_to_queue = reply_to_queue_
        self.process_id = process_id_
        header = MessageHeader()
        header.set_message_name('SvcMgrRegisterLocalServiceRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrRegisterLocalServiceRoutedMessage')
        header.set_routing_key(routing_key)
        super(SvcMgrRegisterLocalServiceRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage`.
        :rtype: SvcMgrRegisterLocalServiceRoutedMessage
        """
        service_guid_ = body_dict.get('serviceGuid')
        node_name_ = body_dict.get('nodeName')
        service_name_ = body_dict.get('serviceName')
        service_group_name_ = body_dict.get('serviceGroupName')
        reply_to_queue_ = body_dict.get('replyToQueue')
        process_id_ = body_dict.get('processId')
        return cls(
            send_to,
            service_guid_=service_guid_,
            node_name_=node_name_,
            service_name_=service_name_,
            service_group_name_=service_group_name_,
            reply_to_queue_=reply_to_queue_,
            process_id_=process_id_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage`.
        :rtype: SvcMgrRegisterLocalServiceRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrRegisterLocalServiceRoutedMessage`.
        :rtype: SvcMgrRegisterLocalServiceRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`SvcMgrRegisterLocalServiceRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrRegisterLocalServiceRoutedMessage`.
        :rtype: SvcMgrRegisterLocalServiceRoutedMessage
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_guid_ = self.service_guid
        node_name_ = self.node_name
        service_name_ = self.service_name
        service_group_name_ = self.service_group_name
        reply_to_queue_ = self.reply_to_queue
        process_id_ = self.process_id
        return {
            'serviceGuid': service_guid_,
            'nodeName': node_name_,
            'serviceName': service_name_,
            'serviceGroupName': service_group_name_,
            'replyToQueue': reply_to_queue_,
            'processId': process_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrRegisterLocalServiceRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrSendServiceStatusRequestBroadcast(BroadcastMessage):
    """
    SvcMgrSendServiceStatusRequestBroadcast JSON broadcast message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrSendServiceStatusRequestBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrSendServiceStatusRequestBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrSendServiceStatusRequestBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast`.
        :rtype: SvcMgrSendServiceStatusRequestBroadcast
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast`.
        :rtype: SvcMgrSendServiceStatusRequestBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrSendServiceStatusRequestBroadcast`.
        :rtype: SvcMgrSendServiceStatusRequestBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrSendServiceStatusRequestBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrSendServiceStatusRequestBroadcast`.
        :rtype: SvcMgrSendServiceStatusRequestBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrPurgeStoppedServicesRequestBroadcast(BroadcastMessage):
    """
    SvcMgrPurgeStoppedServicesRequestBroadcast JSON broadcast message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrPurgeStoppedServicesRequestBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrPurgeStoppedServicesRequestBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrPurgeStoppedServicesRequestBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast`.
        :rtype: SvcMgrPurgeStoppedServicesRequestBroadcast
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast`.
        :rtype: SvcMgrPurgeStoppedServicesRequestBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrPurgeStoppedServicesRequestBroadcast`.
        :rtype: SvcMgrPurgeStoppedServicesRequestBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrPurgeStoppedServicesRequestBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrPurgeStoppedServicesRequestBroadcast`.
        :rtype: SvcMgrPurgeStoppedServicesRequestBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrStopOneServiceRoutedMessage(RoutedMessage):
    """
    SvcMgrStopOneServiceRoutedMessage JSON routed message.
    """
    def __init__(self,
                 send_to,
                 process_id_,
                 service_guid_,
                 kill_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param process_id_: process_id
        :type process_id_: int
        :param service_guid_: service_guid
        :type service_guid_: str
        :param kill_: kill
        :type kill_: bool
        """
        self.process_id = process_id_
        self.service_guid = service_guid_
        self.kill = kill_
        header = MessageHeader()
        header.set_message_name('SvcMgrStopOneServiceRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrStopOneServiceRoutedMessage')
        header.set_routing_key(routing_key)
        super(SvcMgrStopOneServiceRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`SvcMgrStopOneServiceRoutedMessage` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrStopOneServiceRoutedMessage`.
        :rtype: SvcMgrStopOneServiceRoutedMessage
        """
        process_id_ = body_dict.get('processId')
        service_guid_ = body_dict.get('serviceGuid')
        kill_ = body_dict.get('kill')
        return cls(
            send_to,
            process_id_=process_id_,
            service_guid_=service_guid_,
            kill_=kill_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`SvcMgrStopOneServiceRoutedMessage` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrStopOneServiceRoutedMessage`.
        :rtype: SvcMgrStopOneServiceRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`SvcMgrStopOneServiceRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrStopOneServiceRoutedMessage`.
        :rtype: SvcMgrStopOneServiceRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`SvcMgrStopOneServiceRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrStopOneServiceRoutedMessage`.
        :rtype: SvcMgrStopOneServiceRoutedMessage
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        process_id_ = self.process_id
        service_guid_ = self.service_guid
        kill_ = self.kill
        return {
            'processId': process_id_,
            'serviceGuid': service_guid_,
            'kill': kill_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrStopOneServiceRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrStopMultipleServicesBroadcast(BroadcastMessage):
    """
    SvcMgrStopMultipleServicesBroadcast JSON broadcast message.
    """
    def __init__(self,
                 service_name_,
                 node_name_,
                 kill_):
        """
        :param service_name_: service_name
        :type service_name_: str
        :param node_name_: node_name
        :type node_name_: str
        :param kill_: kill
        :type kill_: bool
        """
        self.service_name = service_name_
        self.node_name = node_name_
        self.kill = kill_
        header = MessageHeader()
        header.set_message_name('SvcMgrStopMultipleServicesBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrStopMultipleServicesBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrStopMultipleServicesBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrStopMultipleServicesBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrStopMultipleServicesBroadcast`.
        :rtype: SvcMgrStopMultipleServicesBroadcast
        """
        service_name_ = body_dict.get('serviceName')
        node_name_ = body_dict.get('nodeName')
        kill_ = body_dict.get('kill')
        return cls(
            service_name_=service_name_,
            node_name_=node_name_,
            kill_=kill_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrStopMultipleServicesBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrStopMultipleServicesBroadcast`.
        :rtype: SvcMgrStopMultipleServicesBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrStopMultipleServicesBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrStopMultipleServicesBroadcast`.
        :rtype: SvcMgrStopMultipleServicesBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrStopMultipleServicesBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrStopMultipleServicesBroadcast`.
        :rtype: SvcMgrStopMultipleServicesBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_name_ = self.service_name
        node_name_ = self.node_name
        kill_ = self.kill
        return {
            'serviceName': service_name_,
            'nodeName': node_name_,
            'kill': kill_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrServiceHasShutdownBroadcast(BroadcastMessage):
    """
    SvcMgrServiceHasShutdownBroadcast JSON broadcast message.
    """
    def __init__(self,
                 service_,
                 service_reply_to_):
        """
        :param service_: service
        :type service_: str
        :param service_reply_to_: service_reply_to
        :type service_reply_to_: str
        """
        self.service = service_
        self.service_reply_to = service_reply_to_
        header = MessageHeader()
        header.set_message_name('SvcMgrServiceHasShutdownBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrServiceHasShutdownBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrServiceHasShutdownBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrServiceHasShutdownBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrServiceHasShutdownBroadcast`.
        :rtype: SvcMgrServiceHasShutdownBroadcast
        """
        service_ = body_dict.get('service')
        service_reply_to_ = body_dict.get('serviceReplyTo')
        return cls(
            service_=service_,
            service_reply_to_=service_reply_to_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrServiceHasShutdownBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrServiceHasShutdownBroadcast`.
        :rtype: SvcMgrServiceHasShutdownBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrServiceHasShutdownBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrServiceHasShutdownBroadcast`.
        :rtype: SvcMgrServiceHasShutdownBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrServiceHasShutdownBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrServiceHasShutdownBroadcast`.
        :rtype: SvcMgrServiceHasShutdownBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_ = self.service
        service_reply_to_ = self.service_reply_to
        return {
            'service': service_,
            'serviceReplyTo': service_reply_to_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrConsoleWriteLineBroadcast(BroadcastMessage):
    """
    SvcMgrConsoleWriteLineBroadcast JSON broadcast message.
    """
    def __init__(self,
                 console_write_):
        """
        :param console_write_: console_write
        :type console_write_: str
        """
        self.console_write = console_write_
        header = MessageHeader()
        header.set_message_name('SvcMgrConsoleWriteLineBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrConsoleWriteLineBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrConsoleWriteLineBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrConsoleWriteLineBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrConsoleWriteLineBroadcast`.
        :rtype: SvcMgrConsoleWriteLineBroadcast
        """
        console_write_ = body_dict.get('consoleWrite')
        return cls(
            console_write_=console_write_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrConsoleWriteLineBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrConsoleWriteLineBroadcast`.
        :rtype: SvcMgrConsoleWriteLineBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrConsoleWriteLineBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrConsoleWriteLineBroadcast`.
        :rtype: SvcMgrConsoleWriteLineBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrConsoleWriteLineBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrConsoleWriteLineBroadcast`.
        :rtype: SvcMgrConsoleWriteLineBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        console_write_ = self.console_write
        return {
            'consoleWrite': console_write_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrReportServicesRequestBroadcast(BroadcastMessage):
    """
    SvcMgrReportServicesRequestBroadcast JSON broadcast message.
    """
    def __init__(self,
                 requesting_node_name_):
        """
        :param requesting_node_name_: requesting_node_name
        :type requesting_node_name_: str
        """
        self.requesting_node_name = requesting_node_name_
        header = MessageHeader()
        header.set_message_name('SvcMgrReportServicesRequestBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrReportServicesRequestBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrReportServicesRequestBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrReportServicesRequestBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrReportServicesRequestBroadcast`.
        :rtype: SvcMgrReportServicesRequestBroadcast
        """
        requesting_node_name_ = body_dict.get('requestingNodeName')
        return cls(
            requesting_node_name_=requesting_node_name_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrReportServicesRequestBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrReportServicesRequestBroadcast`.
        :rtype: SvcMgrReportServicesRequestBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrReportServicesRequestBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrReportServicesRequestBroadcast`.
        :rtype: SvcMgrReportServicesRequestBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrReportServicesRequestBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrReportServicesRequestBroadcast`.
        :rtype: SvcMgrReportServicesRequestBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        requesting_node_name_ = self.requesting_node_name
        return {
            'requestingNodeName': requesting_node_name_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrReportServicesResponseBroadcast(BroadcastMessage):
    """
    SvcMgrReportServicesResponseBroadcast JSON broadcast message.
    """
    def __init__(self,
                 node_name_,
                 services_):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param services_: services
        :type services_: list(ServiceInstanceBase)
        """
        self.node_name = node_name_
        self.services = services_
        header = MessageHeader()
        header.set_message_name('SvcMgrReportServicesResponseBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrReportServicesResponseBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrReportServicesResponseBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrReportServicesResponseBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrReportServicesResponseBroadcast`.
        :rtype: SvcMgrReportServicesResponseBroadcast
        """
        node_name_ = body_dict.get('nodeName')
        services_ = body_dict.get('services')
        if services_ is not None:
            new_list = []
            for item in services_:
                item = ServiceInstanceBase.from_dict(item)
                new_list.append(item)
            services_ = new_list
        return cls(
            node_name_=node_name_,
            services_=services_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrReportServicesResponseBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrReportServicesResponseBroadcast`.
        :rtype: SvcMgrReportServicesResponseBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrReportServicesResponseBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrReportServicesResponseBroadcast`.
        :rtype: SvcMgrReportServicesResponseBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrReportServicesResponseBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrReportServicesResponseBroadcast`.
        :rtype: SvcMgrReportServicesResponseBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        services_ = self.services
        if services_ is not None:
            new_list = []
            for item in services_:
                new_list.append(item.to_dict())
            services_ = new_list
        return {
            'nodeName': node_name_,
            'services': services_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrStartServicesBroadcast(BroadcastMessage):
    """
    SvcMgrStartServicesBroadcast JSON broadcast message.
    """
    def __init__(self,
                 all_nodes_,
                 node_names_,
                 all_services_,
                 service_names_,
                 instance_count_):
        """
        :param all_nodes_: all_nodes
        :type all_nodes_: bool
        :param node_names_: node_names
        :type node_names_: list(str)
        :param all_services_: all_services
        :type all_services_: bool
        :param service_names_: service_names
        :type service_names_: list(str)
        :param instance_count_: instance_count
        :type instance_count_: int
        """
        self.all_nodes = all_nodes_
        self.node_names = node_names_
        self.all_services = all_services_
        self.service_names = service_names_
        self.instance_count = instance_count_
        header = MessageHeader()
        header.set_message_name('SvcMgrStartServicesBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'SvcMgrStartServicesBroadcast')
        header.set_routing_key(routing_key)
        super(SvcMgrStartServicesBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SvcMgrStartServicesBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrStartServicesBroadcast`.
        :rtype: SvcMgrStartServicesBroadcast
        """
        all_nodes_ = body_dict.get('allNodes')
        node_names_ = body_dict.get('nodeNames')
        all_services_ = body_dict.get('allServices')
        service_names_ = body_dict.get('serviceNames')
        instance_count_ = body_dict.get('instanceCount')
        return cls(
            all_nodes_=all_nodes_,
            node_names_=node_names_,
            all_services_=all_services_,
            service_names_=service_names_,
            instance_count_=instance_count_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrStartServicesBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrStartServicesBroadcast`.
        :rtype: SvcMgrStartServicesBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrStartServicesBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrStartServicesBroadcast`.
        :rtype: SvcMgrStartServicesBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrStartServicesBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrStartServicesBroadcast`.
        :rtype: SvcMgrStartServicesBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        all_nodes_ = self.all_nodes
        node_names_ = self.node_names
        all_services_ = self.all_services
        service_names_ = self.service_names
        instance_count_ = self.instance_count
        return {
            'allNodes': all_nodes_,
            'nodeNames': node_names_,
            'allServices': all_services_,
            'serviceNames': service_names_,
            'instanceCount': instance_count_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrRunningServiceManagersRequest(RequestMessage):
    """
    SvcMgrRunningServiceManagersRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrRunningServiceManagersRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('ServiceManager', 'SvcMgrRunningServiceManagersRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrRunningServiceManagersRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrRunningServiceManagersRequest`.
        :rtype: SvcMgrRunningServiceManagersRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrRunningServiceManagersRequest`.
        :rtype: SvcMgrRunningServiceManagersRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrRunningServiceManagersRequest`.
        :rtype: SvcMgrRunningServiceManagersRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrRunningServiceManagersRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrRunningServiceManagersRequest`.
        :rtype: SvcMgrRunningServiceManagersRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrRunningServiceManagersResponse(ResponseMessage):
    """
    SvcMgrRunningServiceManagersResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 nodes_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param nodes_: nodes
        :type nodes_: list(NodeStatusRecord)
        """
        self.nodes = nodes_
        header = MessageHeader()
        header.set_message_name('SvcMgrRunningServiceManagersResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrRunningServiceManagersResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrRunningServiceManagersResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrRunningServiceManagersResponse`.
        :rtype: SvcMgrRunningServiceManagersResponse
        """
        nodes_ = body_dict.get('nodes')
        if nodes_ is not None:
            new_list = []
            for item in nodes_:
                item = NodeStatusRecord.from_dict(item)
                new_list.append(item)
            nodes_ = new_list
        return cls(
            request_message,
            nodes_=nodes_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrRunningServiceManagersResponse`.
        :rtype: SvcMgrRunningServiceManagersResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrRunningServiceManagersResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrRunningServiceManagersResponse`.
        :rtype: SvcMgrRunningServiceManagersResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrRunningServiceManagersResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrRunningServiceManagersResponse`.
        :rtype: SvcMgrRunningServiceManagersResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrRunningServiceManagersResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        nodes_ = self.nodes
        if nodes_ is not None:
            new_list = []
            for item in nodes_:
                new_list.append(item.to_dict())
            nodes_ = new_list
        return {
            'nodes': nodes_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrRunningServiceManagersResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrUnavailableLocalServiceRequest(RequestMessage):
    """
    SvcMgrUnavailableLocalServiceRequest JSON request message.
    """
    def __init__(self,
                 send_to,
                 service_guid_,
                 node_name_,
                 service_name_,
                 service_group_name_,
                 process_id_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param service_guid_: service_guid
        :type service_guid_: str
        :param node_name_: node_name
        :type node_name_: str
        :param service_name_: service_name
        :type service_name_: str
        :param service_group_name_: service_group_name
        :type service_group_name_: str
        :param process_id_: process_id
        :type process_id_: int
        """
        self.service_guid = service_guid_
        self.node_name = node_name_
        self.service_name = service_name_
        self.service_group_name = service_group_name_
        self.process_id = process_id_
        header = MessageHeader()
        header.set_message_name('SvcMgrUnavailableLocalServiceRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrUnavailableLocalServiceRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrUnavailableLocalServiceRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceRequest` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceRequest`.
        :rtype: SvcMgrUnavailableLocalServiceRequest
        """
        service_guid_ = body_dict.get('serviceGuid')
        node_name_ = body_dict.get('nodeName')
        service_name_ = body_dict.get('serviceName')
        service_group_name_ = body_dict.get('serviceGroupName')
        process_id_ = body_dict.get('processId')
        return cls(
            send_to,
            service_guid_=service_guid_,
            node_name_=node_name_,
            service_name_=service_name_,
            service_group_name_=service_group_name_,
            process_id_=process_id_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceRequest` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceRequest`.
        :rtype: SvcMgrUnavailableLocalServiceRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceRequest`.
        :rtype: SvcMgrUnavailableLocalServiceRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`SvcMgrUnavailableLocalServiceRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrUnavailableLocalServiceRequest`.
        :rtype: SvcMgrUnavailableLocalServiceRequest
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_guid_ = self.service_guid
        node_name_ = self.node_name
        service_name_ = self.service_name
        service_group_name_ = self.service_group_name
        process_id_ = self.process_id
        return {
            'serviceGuid': service_guid_,
            'nodeName': node_name_,
            'serviceName': service_name_,
            'serviceGroupName': service_group_name_,
            'processId': process_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrUnavailableLocalServiceRequest')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrUnavailableLocalServiceResponse(ResponseMessage):
    """
    SvcMgrUnavailableLocalServiceResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrUnavailableLocalServiceResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrUnavailableLocalServiceResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrUnavailableLocalServiceResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceResponse`.
        :rtype: SvcMgrUnavailableLocalServiceResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceResponse`.
        :rtype: SvcMgrUnavailableLocalServiceResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrUnavailableLocalServiceResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrUnavailableLocalServiceResponse`.
        :rtype: SvcMgrUnavailableLocalServiceResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrUnavailableLocalServiceResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrUnavailableLocalServiceResponse`.
        :rtype: SvcMgrUnavailableLocalServiceResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrUnavailableLocalServiceResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrUnavailableLocalServiceResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetServiceInfoSnapshotRequest(RequestMessage):
    """
    SvcMgrGetServiceInfoSnapshotRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrGetServiceInfoSnapshotRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('ServiceManager', 'SvcMgrGetServiceInfoSnapshotRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrGetServiceInfoSnapshotRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest`.
        :rtype: SvcMgrGetServiceInfoSnapshotRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest`.
        :rtype: SvcMgrGetServiceInfoSnapshotRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotRequest`.
        :rtype: SvcMgrGetServiceInfoSnapshotRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrGetServiceInfoSnapshotRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetServiceInfoSnapshotRequest`.
        :rtype: SvcMgrGetServiceInfoSnapshotRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetServiceInfoSnapshotResponse(ResponseMessage):
    """
    SvcMgrGetServiceInfoSnapshotResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 services_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param services_: services
        :type services_: list(ServiceInstanceBase)
        """
        self.services = services_
        header = MessageHeader()
        header.set_message_name('SvcMgrGetServiceInfoSnapshotResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrGetServiceInfoSnapshotResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrGetServiceInfoSnapshotResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse`.
        :rtype: SvcMgrGetServiceInfoSnapshotResponse
        """
        services_ = body_dict.get('services')
        if services_ is not None:
            new_list = []
            for item in services_:
                item = ServiceInstanceBase.from_dict(item)
                new_list.append(item)
            services_ = new_list
        return cls(
            request_message,
            services_=services_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse`.
        :rtype: SvcMgrGetServiceInfoSnapshotResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetServiceInfoSnapshotResponse`.
        :rtype: SvcMgrGetServiceInfoSnapshotResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrGetServiceInfoSnapshotResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetServiceInfoSnapshotResponse`.
        :rtype: SvcMgrGetServiceInfoSnapshotResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrGetServiceInfoSnapshotResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        services_ = self.services
        if services_ is not None:
            new_list = []
            for item in services_:
                new_list.append(item.to_dict())
            services_ = new_list
        return {
            'services': services_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrGetServiceInfoSnapshotResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetActorTreeRequest(RequestMessage):
    """
    SvcMgrGetActorTreeRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrGetActorTreeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('ServiceManager', 'SvcMgrGetActorTreeRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrGetActorTreeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrGetActorTreeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetActorTreeRequest`.
        :rtype: SvcMgrGetActorTreeRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SvcMgrGetActorTreeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetActorTreeRequest`.
        :rtype: SvcMgrGetActorTreeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetActorTreeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetActorTreeRequest`.
        :rtype: SvcMgrGetActorTreeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrGetActorTreeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetActorTreeRequest`.
        :rtype: SvcMgrGetActorTreeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetActorTreeResponse(ResponseMessage):
    """
    SvcMgrGetActorTreeResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 node_name_,
                 actor_list_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param node_name_: node_name
        :type node_name_: str
        :param actor_list_: actor_list
        :type actor_list_: list(str)
        """
        self.node_name = node_name_
        self.actor_list = actor_list_
        header = MessageHeader()
        header.set_message_name('SvcMgrGetActorTreeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrGetActorTreeResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrGetActorTreeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`SvcMgrGetActorTreeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetActorTreeResponse`.
        :rtype: SvcMgrGetActorTreeResponse
        """
        node_name_ = body_dict.get('nodeName')
        actor_list_ = body_dict.get('actorList')
        return cls(
            request_message,
            node_name_=node_name_,
            actor_list_=actor_list_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrGetActorTreeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetActorTreeResponse`.
        :rtype: SvcMgrGetActorTreeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetActorTreeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetActorTreeResponse`.
        :rtype: SvcMgrGetActorTreeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrGetActorTreeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetActorTreeResponse`.
        :rtype: SvcMgrGetActorTreeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrGetActorTreeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        actor_list_ = self.actor_list
        return {
            'nodeName': node_name_,
            'actorList': actor_list_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrGetActorTreeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetServiceGroupsRequest(RequestMessage):
    """
    SvcMgrGetServiceGroupsRequest JSON request message.
    """
    def __init__(self,
                 send_to,
                 service_name_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param service_name_: service_name
        :type service_name_: str
        """
        self.service_name = service_name_
        header = MessageHeader()
        header.set_message_name('SvcMgrGetServiceGroupsRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrGetServiceGroupsRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrGetServiceGroupsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsRequest` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetServiceGroupsRequest`.
        :rtype: SvcMgrGetServiceGroupsRequest
        """
        service_name_ = body_dict.get('serviceName')
        return cls(
            send_to,
            service_name_=service_name_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsRequest` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetServiceGroupsRequest`.
        :rtype: SvcMgrGetServiceGroupsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetServiceGroupsRequest`.
        :rtype: SvcMgrGetServiceGroupsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`SvcMgrGetServiceGroupsRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetServiceGroupsRequest`.
        :rtype: SvcMgrGetServiceGroupsRequest
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_name_ = self.service_name
        return {
            'serviceName': service_name_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrGetServiceGroupsRequest')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrGetServiceGroupsResponse(ResponseMessage):
    """
    SvcMgrGetServiceGroupsResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 groups_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param groups_: groups
        :type groups_: list(ServiceGroup)
        """
        self.groups = groups_
        header = MessageHeader()
        header.set_message_name('SvcMgrGetServiceGroupsResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrGetServiceGroupsResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrGetServiceGroupsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrGetServiceGroupsResponse`.
        :rtype: SvcMgrGetServiceGroupsResponse
        """
        groups_ = body_dict.get('groups')
        if groups_ is not None:
            new_list = []
            for item in groups_:
                item = ServiceGroup.from_dict(item)
                new_list.append(item)
            groups_ = new_list
        return cls(
            request_message,
            groups_=groups_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrGetServiceGroupsResponse`.
        :rtype: SvcMgrGetServiceGroupsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrGetServiceGroupsResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrGetServiceGroupsResponse`.
        :rtype: SvcMgrGetServiceGroupsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrGetServiceGroupsResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrGetServiceGroupsResponse`.
        :rtype: SvcMgrGetServiceGroupsResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrGetServiceGroupsResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        groups_ = self.groups
        if groups_ is not None:
            new_list = []
            for item in groups_:
                new_list.append(item.to_dict())
            groups_ = new_list
        return {
            'groups': groups_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrGetServiceGroupsResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrUpdateServiceGroupRequest(RequestMessage):
    """
    SvcMgrUpdateServiceGroupRequest JSON request message.
    """
    def __init__(self,
                 send_to,
                 service_name_,
                 group_):
        """
        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param service_name_: service_name
        :type service_name_: str
        :param group_: group
        :type group_: ServiceGroup
        """
        self.service_name = service_name_
        self.group = group_
        header = MessageHeader()
        header.set_message_name('SvcMgrUpdateServiceGroupRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrUpdateServiceGroupRequest')
        header.set_routing_key(routing_key)
        super(SvcMgrUpdateServiceGroupRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, send_to, body_dict):
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupRequest` using a dictionary.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupRequest`.
        :rtype: SvcMgrUpdateServiceGroupRequest
        """
        service_name_ = body_dict.get('serviceName')
        group_ = body_dict.get('group')
        if group_ is not None:
            group_ = ServiceGroup.from_dict(group_)
        return cls(
            send_to,
            service_name_=service_name_,
            group_=group_
        )

    @classmethod
    def from_json(cls, send_to, body_json):
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupRequest` using a JSON string.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupRequest`.
        :rtype: SvcMgrUpdateServiceGroupRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(send_to, body_dict)

    @classmethod
    def from_body_bytes(cls, send_to, body_bytes):
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupRequest`.
        :rtype: SvcMgrUpdateServiceGroupRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(send_to, body_json)

    @classmethod
    def from_message(cls, send_to, message):
        """
        Create a new instance of :class`SvcMgrUpdateServiceGroupRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrUpdateServiceGroupRequest`.
        :rtype: SvcMgrUpdateServiceGroupRequest
        """
        instance = cls.from_body_bytes(send_to, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        service_name_ = self.service_name
        group_ = self.group
        if group_ is not None:
            group_ = group_.to_dict()
        return {
            'serviceName': service_name_,
            'group': group_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, send_to, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param send_to: The value to use as a routing parameter.
        :type send_to: str
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(send_to, 'SvcMgrUpdateServiceGroupRequest')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class SvcMgrUpdateServiceGroupResponse(ResponseMessage):
    """
    SvcMgrUpdateServiceGroupResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('SvcMgrUpdateServiceGroupResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'SvcMgrUpdateServiceGroupResponse')
            header.set_routing_key(routing_key)
        super(SvcMgrUpdateServiceGroupResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupResponse`.
        :rtype: SvcMgrUpdateServiceGroupResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupResponse`.
        :rtype: SvcMgrUpdateServiceGroupResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`SvcMgrUpdateServiceGroupResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SvcMgrUpdateServiceGroupResponse`.
        :rtype: SvcMgrUpdateServiceGroupResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`SvcMgrUpdateServiceGroupResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`SvcMgrUpdateServiceGroupResponse`.
        :rtype: SvcMgrUpdateServiceGroupResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'SvcMgrUpdateServiceGroupResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'SvcMgrUpdateServiceGroupResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body
