# -*- coding: utf-8 -*-
"""
General use utility functions
"""
from __future__ import absolute_import, print_function

# Import python libs
import sys


def is_windows():
    """
    Returns whether the system platform is Windows.

    :return: ``True`` if the system platform is Windows. ``False`` otherwise.
    :rtype: bool
    """
    return sys.platform.startswith('win')


def is_linux():
    """
    Returns whether the system platform is Linux.

    :return: ``True`` if the system platform is Linux. ``False`` otherwise.
    :rtype: bool
    """
    return sys.platform.startswith('linux')


def eprint(*args, **kwargs):
    """
    Print to stderr.

    Takes same parameters as the built-in print command.
    """
    print(*args, file=sys.stderr, **kwargs)
