# -*- coding: utf-8 -*-
"""
DO NOT EDIT! This file is auto-generated

Classes for Skyline Message Bus usage.
"""
from __future__ import absolute_import

# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import

# Import local libs
# pylint: disable=import-error
from niskyline.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from niskyline.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from niskyline.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from niskyline.messagebus.message_base import MessageBase
from niskyline.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from niskyline.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from niskyline.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import
# pylint: enable=import-error

if sys.version_info[0] >= 3:
    long = int  # pylint: disable=redefined-builtin,invalid-name


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes


#
# TagMessageObjects namespace
#


class DataType(object):  # pylint: disable=too-few-public-methods
    """
    DataType normal enum.
    """
    NONE = 0
    DOUBLE = 1
    INT = 2
    STRING = 3
    BOOLEAN = 4
    U_INT64 = 5
    DATE_TIME = 6
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DOUBLE',
        2: 'INT',
        3: 'STRING',
        4: 'BOOLEAN',
        5: 'U_INT64',
        6: 'DATE_TIME'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DOUBLE': 1,
        'INT': 2,
        'STRING': 3,
        'BOOLEAN': 4,
        'U_INT64': 5,
        'DATE_TIME': 6
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`DataType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`DataType`.
        :rtype: DataType
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class Aggregation(object):  # pylint: disable=too-few-public-methods
    """
    Aggregation normal enum.
    """
    NONE = 0
    ENABLE = 1
    DISABLE = 2
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'ENABLE',
        2: 'DISABLE'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'ENABLE': 1,
        'DISABLE': 2
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`Aggregation` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`Aggregation`.
        :rtype: Aggregation
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class RetentionType(object):  # pylint: disable=too-few-public-methods
    """
    RetentionType normal enum.
    """
    NONE = 0
    DURATION = 1
    COUNT = 2
    PERMANENT = 3
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DURATION',
        2: 'COUNT',
        3: 'PERMANENT'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DURATION': 1,
        'COUNT': 2,
        'PERMANENT': 3
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`RetentionType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`RetentionType`.
        :rtype: RetentionType
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class TagFields(object):  # pylint: disable=too-few-public-methods
    """
    TagFields flags enum.
    """
    KEYWORDS = 1
    PROPERTIES = 2
    COLLECT_AGGREGATES = 4
    _INT_TO_STRING = {
        1: 'KEYWORDS',
        2: 'PROPERTIES',
        4: 'COLLECT_AGGREGATES'
    }
    _STRING_TO_INT = {
        'KEYWORDS': 1,
        'PROPERTIES': 2,
        'COLLECT_AGGREGATES': 4
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_list(cls, value_list):
        """
        Create a new instance of :class:`TagFields` using a list.

        :param value_list: A list of string values for the enum.
        :type value_list: list(str)
        :return: A new instance of :class:`TagFields`.
        :rtype: TagFields
        """
        value = 0
        for value_string in value_list:
            value = value | cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_list(self):
        """
        Returns a list of strings representing the enum.

        :return: A list of strings representing the enum.
        :rtype: list(str)
        """
        value_list = []
        for value_int, value_string in self._INT_TO_STRING:
            if self._value & value_int:
                value_list.append(value_string)
        if not value_list and 0 in self._INT_TO_STRING:
            value_list.append(self._INT_TO_STRING[0])
        return value_list


class SortOrder(object):  # pylint: disable=too-few-public-methods
    """
    SortOrder normal enum.
    """
    ASCENDING = 0
    DESCENDING = 1
    _INT_TO_STRING = {
        0: 'ASCENDING',
        1: 'DESCENDING'
    }
    _STRING_TO_INT = {
        'ASCENDING': 0,
        'DESCENDING': 1
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`SortOrder` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`SortOrder`.
        :rtype: SortOrder
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class Tag(object):
    """
    Tag custom data type.
    """
    def __init__(self,
                 path_,
                 type_,
                 properties_,
                 keywords_,
                 collect_aggregates_):
        """
        :param path_: path
        :type path_: str
        :param type_: type
        :type type_: DataType
        :param properties_: properties
        :type properties_: dict(str, str)
        :param keywords_: keywords
        :type keywords_: list(str)
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: bool
        """
        self.path = path_
        self.type = type_
        self.properties = properties_
        self.keywords = keywords_
        self.collect_aggregates = collect_aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Tag` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        path_ = body_dict.get('path')
        type_ = body_dict.get('type')
        if type_ is not None:
            if isinstance(type_, str):
                type_ = DataType.from_string(type_)
            elif isinstance(type_, int):
                type_ = DataType(type_)
        properties_ = body_dict.get('properties')
        keywords_ = body_dict.get('keywords')
        collect_aggregates_ = body_dict.get('collectAggregates')
        return cls(
            path_=path_,
            type_=type_,
            properties_=properties_,
            keywords_=keywords_,
            collect_aggregates_=collect_aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Tag` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Tag` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        type_ = self.type
        if type_ is not None:
            type_ = type_.to_string()
        properties_ = self.properties
        keywords_ = self.keywords
        collect_aggregates_ = self.collect_aggregates
        return {
            'path': path_,
            'type': type_,
            'properties': properties_,
            'keywords': keywords_,
            'collectAggregates': collect_aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class PartialTagInfo(object):
    """
    PartialTagInfo custom data type.
    """
    def __init__(self,
                 tag_,
                 changes_):
        """
        :param tag_: tag
        :type tag_: Tag
        :param changes_: changes
        :type changes_: TagFields
        """
        self.tag = tag_
        self.changes = changes_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`PartialTagInfo` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        tag_ = body_dict.get('tag')
        if tag_ is not None:
            tag_ = Tag.from_dict(tag_)
        changes_ = body_dict.get('changes')
        if changes_ is not None:
            if isinstance(changes_, list):
                changes_ = TagFields.from_list(changes_)
            elif isinstance(changes_, int):
                changes_ = TagFields(changes_)
        return cls(
            tag_=tag_,
            changes_=changes_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`PartialTagInfo` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`PartialTagInfo` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = self.tag
        if tag_ is not None:
            tag_ = tag_.to_dict()
        changes_ = self.changes
        if changes_ is not None:
            changes_ = changes_.to_list()
        return {
            'tag': tag_,
            'changes': changes_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TypedValue(object):
    """
    TypedValue custom data type.
    """
    def __init__(self,
                 type_,
                 value_):
        """
        :param type_: type
        :type type_: DataType
        :param value_: value
        :type value_: str
        """
        self.type = type_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TypedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        type_ = body_dict.get('type')
        if type_ is not None:
            if isinstance(type_, str):
                type_ = DataType.from_string(type_)
            elif isinstance(type_, int):
                type_ = DataType(type_)
        value_ = body_dict.get('value')
        return cls(
            type_=type_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TypedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TypedValue` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        type_ = self.type
        if type_ is not None:
            type_ = type_.to_string()
        value_ = self.value
        return {
            'type': type_,
            'value': value_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TimestampedValue(object):
    """
    TimestampedValue custom data type.
    """
    def __init__(self,
                 timestamp_,
                 value_):
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        """
        self.timestamp = timestamp_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TimestampedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        timestamp_ = body_dict.get('timestamp')
        if timestamp_ is not None and not isinstance(timestamp_, datetime):
            timestamp_ = to_datetime(timestamp_)
        value_ = body_dict.get('value')
        if value_ is not None:
            value_ = TypedValue.from_dict(value_)
        return cls(
            timestamp_=timestamp_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TimestampedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TimestampedValue` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_ = self.timestamp
        if timestamp_ is not None and isinstance(timestamp_, datetime):
            timestamp_ = from_datetime(timestamp_)
        value_ = self.value
        if value_ is not None:
            value_ = value_.to_dict()
        return {
            'timestamp': timestamp_,
            'value': value_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class Update(object):
    """
    Update custom data type.
    """
    def __init__(self,
                 path_,
                 updates_):
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: list(TimestampedValue)
        """
        self.path = path_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Update` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        path_ = body_dict.get('path')
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = TimestampedValue.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            path_=path_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Update` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Update` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'path': path_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AggregateValue(object):
    """
    AggregateValue custom data type.
    """
    def __init__(self,
                 count_,
                 avg_,
                 min_,
                 max_):
        """
        :param count_: count
        :type count_: int
        :param avg_: avg
        :type avg_: float
        :param min_: min
        :type min_: str
        :param max_: max
        :type max_: str
        """
        self.count = count_
        self.avg = avg_
        self.min = min_
        self.max = max_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AggregateValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        count_ = body_dict.get('count')
        avg_ = body_dict.get('avg')
        min_ = body_dict.get('min')
        max_ = body_dict.get('max')
        return cls(
            count_=count_,
            avg_=avg_,
            min_=min_,
            max_=max_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AggregateValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AggregateValue` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        count_ = self.count
        avg_ = self.avg
        min_ = self.min
        max_ = self.max
        return {
            'count': count_,
            'avg': avg_,
            'min': min_,
            'max': max_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class CurrentValues(object):
    """
    CurrentValues custom data type.
    """
    def __init__(self,
                 path_,
                 current_,
                 aggregates_):
        """
        :param path_: path
        :type path_: str
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.path = path_
        self.current = current_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`CurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        path_ = body_dict.get('path')
        current_ = body_dict.get('current')
        if current_ is not None:
            current_ = TimestampedValue.from_dict(current_)
        aggregates_ = body_dict.get('aggregates')
        if aggregates_ is not None:
            aggregates_ = AggregateValue.from_dict(aggregates_)
        return cls(
            path_=path_,
            current_=current_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`CurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`CurrentValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        current_ = self.current
        if current_ is not None:
            current_ = current_.to_dict()
        aggregates_ = self.aggregates
        if aggregates_ is not None:
            aggregates_ = aggregates_.to_dict()
        return {
            'path': path_,
            'current': current_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TimestampedValueWithAggregate(object):
    """
    TimestampedValueWithAggregate custom data type.
    """
    def __init__(self,
                 timestamp_,
                 value_,
                 aggregates_):
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.timestamp = timestamp_
        self.value = value_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        timestamp_ = body_dict.get('timestamp')
        if timestamp_ is not None and not isinstance(timestamp_, datetime):
            timestamp_ = to_datetime(timestamp_)
        value_ = body_dict.get('value')
        if value_ is not None:
            value_ = TypedValue.from_dict(value_)
        aggregates_ = body_dict.get('aggregates')
        if aggregates_ is not None:
            aggregates_ = AggregateValue.from_dict(aggregates_)
        return cls(
            timestamp_=timestamp_,
            value_=value_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        timestamp_ = self.timestamp
        if timestamp_ is not None and isinstance(timestamp_, datetime):
            timestamp_ = from_datetime(timestamp_)
        value_ = self.value
        if value_ is not None:
            value_ = value_.to_dict()
        aggregates_ = self.aggregates
        if aggregates_ is not None:
            aggregates_ = aggregates_.to_dict()
        return {
            'timestamp': timestamp_,
            'value': value_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class UpdateWithAggregates(object):
    """
    UpdateWithAggregates custom data type.
    """
    def __init__(self,
                 path_,
                 updates_):
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: list(TimestampedValueWithAggregate)
        """
        self.path = path_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        path_ = body_dict.get('path')
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = TimestampedValueWithAggregate.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            path_=path_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`UpdateWithAggregates` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'path': path_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class UpdateWithAggregatesAndMetadata(object):
    """
    UpdateWithAggregatesAndMetadata custom data type.
    """
    def __init__(self,
                 tag_,
                 updates_):
        """
        :param tag_: tag
        :type tag_: Tag
        :param updates_: updates
        :type updates_: list(TimestampedValueWithAggregate)
        """
        self.tag = tag_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        tag_ = body_dict.get('tag')
        if tag_ is not None:
            tag_ = Tag.from_dict(tag_)
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = TimestampedValueWithAggregate.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            tag_=tag_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = self.tag
        if tag_ is not None:
            tag_ = tag_.to_dict()
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'tag': tag_,
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagWithValues(object):
    """
    TagWithValues custom data type.
    """
    def __init__(self,
                 tag_,
                 current_,
                 aggregates_):
        """
        :param tag_: tag
        :type tag_: Tag
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.tag = tag_
        self.current = current_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagWithValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        tag_ = body_dict.get('tag')
        if tag_ is not None:
            tag_ = Tag.from_dict(tag_)
        current_ = body_dict.get('current')
        if current_ is not None:
            current_ = TimestampedValue.from_dict(current_)
        aggregates_ = body_dict.get('aggregates')
        if aggregates_ is not None:
            aggregates_ = AggregateValue.from_dict(aggregates_)
        return cls(
            tag_=tag_,
            current_=current_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagWithValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagWithValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_ = self.tag
        if tag_ is not None:
            tag_ = tag_.to_dict()
        current_ = self.current
        if current_ is not None:
            current_ = current_.to_dict()
        aggregates_ = self.aggregates
        if aggregates_ is not None:
            aggregates_ = aggregates_.to_dict()
        return {
            'tag': tag_,
            'current': current_,
            'aggregates': aggregates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class Selection(object):
    """
    Selection custom data type.
    """
    def __init__(self,
                 id_,
                 search_paths_,
                 inactivity_timeout_):
        """
        :param id_: id
        :type id_: str
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        :param inactivity_timeout_: inactivity_timeout
        :type inactivity_timeout_: int
        """
        self.id = id_  # pylint: disable=invalid-name
        self.search_paths = search_paths_
        self.inactivity_timeout = inactivity_timeout_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Selection` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        id_ = body_dict.get('id')
        search_paths_ = body_dict.get('searchPaths')
        inactivity_timeout_ = body_dict.get('inactivityTimeout')
        return cls(
            id_=id_,
            search_paths_=search_paths_,
            inactivity_timeout_=inactivity_timeout_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Selection` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Selection` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        search_paths_ = self.search_paths
        inactivity_timeout_ = self.inactivity_timeout
        return {
            'id': id_,
            'searchPaths': search_paths_,
            'inactivityTimeout': inactivity_timeout_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class NodeTagPath(object):
    """
    NodeTagPath custom data type.
    """
    def __init__(self,
                 node_name_,
                 tag_path_):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param tag_path_: tag_path
        :type tag_path_: str
        """
        self.node_name = node_name_
        self.tag_path = tag_path_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`NodeTagPath` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        node_name_ = body_dict.get('nodeName')
        tag_path_ = body_dict.get('tagPath')
        return cls(
            node_name_=node_name_,
            tag_path_=tag_path_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`NodeTagPath` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`NodeTagPath` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        tag_path_ = self.tag_path
        return {
            'nodeName': node_name_,
            'tagPath': tag_path_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SubscriptionValues(object):
    """
    SubscriptionValues custom data type.
    """
    def __init__(self,
                 subscription_id_):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        subscription_id_ = body_dict.get('subscriptionId')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = self.subscription_id
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class NodeCurrentValues(object):
    """
    NodeCurrentValues custom data type.
    """
    def __init__(self,
                 node_name_,
                 current_values_):
        """
        :param node_name_: node_name
        :type node_name_: str
        :param current_values_: current_values
        :type current_values_: list(CurrentValues)
        """
        self.node_name = node_name_
        self.current_values = current_values_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`NodeCurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        node_name_ = body_dict.get('nodeName')
        current_values_ = body_dict.get('currentValues')
        if current_values_ is not None:
            new_list = []
            for item in current_values_:
                item = CurrentValues.from_dict(item)
                new_list.append(item)
            current_values_ = new_list
        return cls(
            node_name_=node_name_,
            current_values_=current_values_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`NodeCurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`NodeCurrentValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        node_name_ = self.node_name
        current_values_ = self.current_values
        if current_values_ is not None:
            new_list = []
            for item in current_values_:
                new_list.append(item.to_dict())
            current_values_ = new_list
        return {
            'nodeName': node_name_,
            'currentValues': current_values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class HistoricalValue(object):
    """
    HistoricalValue custom data type.
    """
    def __init__(self,
                 id_,
                 path_,
                 type_,
                 value_,
                 timestamp_,
                 properties_,
                 expiration_date_):
        """
        :param id_: id
        :type id_: str
        :param path_: path
        :type path_: str
        :param type_: type
        :type type_: DataType
        :param value_: value
        :type value_: str
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param properties_: properties
        :type properties_: dict(str, str)
        :param expiration_date_: expiration_date
        :type expiration_date_: datetime
        """
        self.id = id_  # pylint: disable=invalid-name
        self.path = path_
        self.type = type_
        self.value = value_
        self.timestamp = timestamp_
        self.properties = properties_
        self.expiration_date = expiration_date_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`HistoricalValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`HistoricalValue`.
        :rtype: HistoricalValue
        """
        id_ = body_dict.get('id')
        path_ = body_dict.get('path')
        type_ = body_dict.get('type')
        if type_ is not None:
            if isinstance(type_, str):
                type_ = DataType.from_string(type_)
            elif isinstance(type_, int):
                type_ = DataType(type_)
        value_ = body_dict.get('value')
        timestamp_ = body_dict.get('timestamp')
        if timestamp_ is not None and not isinstance(timestamp_, datetime):
            timestamp_ = to_datetime(timestamp_)
        properties_ = body_dict.get('properties')
        expiration_date_ = body_dict.get('expirationDate')
        if expiration_date_ is not None and not isinstance(expiration_date_, datetime):
            expiration_date_ = to_datetime(expiration_date_)
        return cls(
            id_=id_,
            path_=path_,
            type_=type_,
            value_=value_,
            timestamp_=timestamp_,
            properties_=properties_,
            expiration_date_=expiration_date_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`HistoricalValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`HistoricalValue`.
        :rtype: HistoricalValue
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`HistoricalValue` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`HistoricalValue`.
        :rtype: HistoricalValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        path_ = self.path
        type_ = self.type
        if type_ is not None:
            type_ = type_.to_string()
        value_ = self.value
        timestamp_ = self.timestamp
        if timestamp_ is not None and isinstance(timestamp_, datetime):
            timestamp_ = from_datetime(timestamp_)
        properties_ = self.properties
        expiration_date_ = self.expiration_date
        if expiration_date_ is not None and isinstance(expiration_date_, datetime):
            expiration_date_ = from_datetime(expiration_date_)
        return {
            'id': id_,
            'path': path_,
            'type': type_,
            'value': value_,
            'timestamp': timestamp_,
            'properties': properties_,
            'expirationDate': expiration_date_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class HistoricalTagQueryRange(object):
    """
    HistoricalTagQueryRange custom data type.
    """
    def __init__(self,
                 path_,
                 start_time_,
                 end_time_):
        """
        :param path_: path
        :type path_: str
        :param start_time_: start_time
        :type start_time_: datetime
        :param end_time_: end_time
        :type end_time_: datetime
        """
        self.path = path_
        self.start_time = start_time_
        self.end_time = end_time_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`HistoricalTagQueryRange` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`HistoricalTagQueryRange`.
        :rtype: HistoricalTagQueryRange
        """
        path_ = body_dict.get('path')
        start_time_ = body_dict.get('startTime')
        if start_time_ is not None and not isinstance(start_time_, datetime):
            start_time_ = to_datetime(start_time_)
        end_time_ = body_dict.get('endTime')
        if end_time_ is not None and not isinstance(end_time_, datetime):
            end_time_ = to_datetime(end_time_)
        return cls(
            path_=path_,
            start_time_=start_time_,
            end_time_=end_time_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`HistoricalTagQueryRange` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`HistoricalTagQueryRange`.
        :rtype: HistoricalTagQueryRange
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`HistoricalTagQueryRange` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`HistoricalTagQueryRange`.
        :rtype: HistoricalTagQueryRange
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        start_time_ = self.start_time
        if start_time_ is not None and isinstance(start_time_, datetime):
            start_time_ = from_datetime(start_time_)
        end_time_ = self.end_time
        if end_time_ is not None and isinstance(end_time_, datetime):
            end_time_ = from_datetime(end_time_)
        return {
            'path': path_,
            'startTime': start_time_,
            'endTime': end_time_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class HistoricalTagQuery(object):
    """
    HistoricalTagQuery custom data type.
    """
    def __init__(self,
                 paths_,
                 start_time_,
                 end_time_,
                 skip_,
                 take_,
                 decimation_,
                 sort_order_):
        """
        :param paths_: paths
        :type paths_: list(str)
        :param start_time_: start_time
        :type start_time_: datetime
        :param end_time_: end_time
        :type end_time_: datetime
        :param skip_: skip
        :type skip_: int
        :param take_: take
        :type take_: int
        :param decimation_: decimation
        :type decimation_: int
        :param sort_order_: sort_order
        :type sort_order_: SortOrder
        """
        self.paths = paths_
        self.start_time = start_time_
        self.end_time = end_time_
        self.skip = skip_
        self.take = take_
        self.decimation = decimation_
        self.sort_order = sort_order_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`HistoricalTagQuery` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`HistoricalTagQuery`.
        :rtype: HistoricalTagQuery
        """
        paths_ = body_dict.get('paths')
        start_time_ = body_dict.get('startTime')
        if start_time_ is not None and not isinstance(start_time_, datetime):
            start_time_ = to_datetime(start_time_)
        end_time_ = body_dict.get('endTime')
        if end_time_ is not None and not isinstance(end_time_, datetime):
            end_time_ = to_datetime(end_time_)
        skip_ = body_dict.get('skip')
        take_ = body_dict.get('take')
        decimation_ = body_dict.get('decimation')
        sort_order_ = body_dict.get('sortOrder')
        if sort_order_ is not None:
            if isinstance(sort_order_, str):
                sort_order_ = SortOrder.from_string(sort_order_)
            elif isinstance(sort_order_, int):
                sort_order_ = SortOrder(sort_order_)
        return cls(
            paths_=paths_,
            start_time_=start_time_,
            end_time_=end_time_,
            skip_=skip_,
            take_=take_,
            decimation_=decimation_,
            sort_order_=sort_order_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`HistoricalTagQuery` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`HistoricalTagQuery`.
        :rtype: HistoricalTagQuery
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`HistoricalTagQuery` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`HistoricalTagQuery`.
        :rtype: HistoricalTagQuery
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = self.paths
        start_time_ = self.start_time
        if start_time_ is not None and isinstance(start_time_, datetime):
            start_time_ = from_datetime(start_time_)
        end_time_ = self.end_time
        if end_time_ is not None and isinstance(end_time_, datetime):
            end_time_ = from_datetime(end_time_)
        skip_ = self.skip
        take_ = self.take
        decimation_ = self.decimation
        sort_order_ = self.sort_order
        if sort_order_ is not None:
            sort_order_ = sort_order_.to_string()
        return {
            'paths': paths_,
            'startTime': start_time_,
            'endTime': end_time_,
            'skip': skip_,
            'take': take_,
            'decimation': decimation_,
            'sortOrder': sort_order_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class HistoricalTagAsyncQueryJob(object):
    """
    HistoricalTagAsyncQueryJob custom data type.
    """
    def __init__(self,
                 query_,
                 request_id_,
                 has_error_):
        """
        :param query_: query
        :type query_: HistoricalTagQuery
        :param request_id_: request_id
        :type request_id_: str
        :param has_error_: has_error
        :type has_error_: bool
        """
        self.query = query_
        self.request_id = request_id_
        self.has_error = has_error_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`HistoricalTagAsyncQueryJob` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`HistoricalTagAsyncQueryJob`.
        :rtype: HistoricalTagAsyncQueryJob
        """
        query_ = body_dict.get('query')
        if query_ is not None:
            query_ = HistoricalTagQuery.from_dict(query_)
        request_id_ = body_dict.get('requestId')
        has_error_ = body_dict.get('hasError')
        return cls(
            query_=query_,
            request_id_=request_id_,
            has_error_=has_error_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`HistoricalTagAsyncQueryJob` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`HistoricalTagAsyncQueryJob`.
        :rtype: HistoricalTagAsyncQueryJob
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`HistoricalTagAsyncQueryJob` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`HistoricalTagAsyncQueryJob`.
        :rtype: HistoricalTagAsyncQueryJob
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        query_ = self.query
        if query_ is not None:
            query_ = query_.to_dict()
        request_id_ = self.request_id
        has_error_ = self.has_error
        return {
            'query': query_,
            'requestId': request_id_,
            'hasError': has_error_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class HistoricalValueUpdate(object):
    """
    HistoricalValueUpdate custom data type.
    """
    def __init__(self,
                 id_,
                 properties_,
                 expiration_date_):
        """
        :param id_: id
        :type id_: str
        :param properties_: properties
        :type properties_: dict(str, str)
        :param expiration_date_: expiration_date
        :type expiration_date_: datetime
        """
        self.id = id_  # pylint: disable=invalid-name
        self.properties = properties_
        self.expiration_date = expiration_date_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`HistoricalValueUpdate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`HistoricalValueUpdate`.
        :rtype: HistoricalValueUpdate
        """
        id_ = body_dict.get('id')
        properties_ = body_dict.get('properties')
        expiration_date_ = body_dict.get('expirationDate')
        if expiration_date_ is not None and not isinstance(expiration_date_, datetime):
            expiration_date_ = to_datetime(expiration_date_)
        return cls(
            id_=id_,
            properties_=properties_,
            expiration_date_=expiration_date_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`HistoricalValueUpdate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`HistoricalValueUpdate`.
        :rtype: HistoricalValueUpdate
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`HistoricalValueUpdate` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`HistoricalValueUpdate`.
        :rtype: HistoricalValueUpdate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        properties_ = self.properties
        expiration_date_ = self.expiration_date
        if expiration_date_ is not None and isinstance(expiration_date_, datetime):
            expiration_date_ = from_datetime(expiration_date_)
        return {
            'id': id_,
            'properties': properties_,
            'expirationDate': expiration_date_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ErrorEntry(object):
    """
    ErrorEntry custom data type.
    """
    def __init__(self,
                 name_,
                 message_,
                 args_,
                 inner_errors_,
                 resource_id_,
                 resource_type_):
        """
        :param name_: name
        :type name_: str
        :param message_: message
        :type message_: str
        :param args_: args
        :type args_: list(str)
        :param inner_errors_: inner_errors
        :type inner_errors_: list(ErrorEntry)
        :param resource_id_: resource_id
        :type resource_id_: str
        :param resource_type_: resource_type
        :type resource_type_: str
        """
        self.name = name_
        self.message = message_
        self.args = args_
        self.inner_errors = inner_errors_
        self.resource_id = resource_id_
        self.resource_type = resource_type_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ErrorEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        name_ = body_dict.get('name')
        message_ = body_dict.get('message')
        args_ = body_dict.get('args')
        inner_errors_ = body_dict.get('innerErrors')
        if inner_errors_ is not None:
            new_list = []
            for item in inner_errors_:
                item = ErrorEntry.from_dict(item)
                new_list.append(item)
            inner_errors_ = new_list
        resource_id_ = body_dict.get('resourceId')
        resource_type_ = body_dict.get('resourceType')
        return cls(
            name_=name_,
            message_=message_,
            args_=args_,
            inner_errors_=inner_errors_,
            resource_id_=resource_id_,
            resource_type_=resource_type_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ErrorEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ErrorEntry` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = self.name
        message_ = self.message
        args_ = self.args
        inner_errors_ = self.inner_errors
        if inner_errors_ is not None:
            new_list = []
            for item in inner_errors_:
                new_list.append(item.to_dict())
            inner_errors_ = new_list
        resource_id_ = self.resource_id
        resource_type_ = self.resource_type
        return {
            'name': name_,
            'message': message_,
            'args': args_,
            'innerErrors': inner_errors_,
            'resourceId': resource_id_,
            'resourceType': resource_type_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagHistorianValues(object):
    """
    TagHistorianValues custom data type.
    """
    def __init__(self,
                 values_,
                 total_count_,
                 errors_,
                 failed_):
        """
        :param values_: values
        :type values_: dict(str, list)
        :param total_count_: total_count
        :type total_count_: int
        :param errors_: errors
        :type errors_: ErrorEntry
        :param failed_: failed
        :type failed_: list(str)
        """
        self.values = values_
        self.total_count = total_count_
        self.errors = errors_
        self.failed = failed_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianValues`.
        :rtype: TagHistorianValues
        """
        values_ = body_dict.get('values')
        total_count_ = body_dict.get('totalCount')
        errors_ = body_dict.get('errors')
        if errors_ is not None:
            errors_ = ErrorEntry.from_dict(errors_)
        failed_ = body_dict.get('failed')
        return cls(
            values_=values_,
            total_count_=total_count_,
            errors_=errors_,
            failed_=failed_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianValues`.
        :rtype: TagHistorianValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianValues`.
        :rtype: TagHistorianValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        values_ = self.values
        total_count_ = self.total_count
        errors_ = self.errors
        if errors_ is not None:
            errors_ = errors_.to_dict()
        failed_ = self.failed
        return {
            'values': values_,
            'totalCount': total_count_,
            'errors': errors_,
            'failed': failed_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagHistorianAsyncValues(object):
    """
    TagHistorianAsyncValues custom data type.
    """
    def __init__(self,
                 request_id_,
                 values_,
                 total_count_,
                 errors_,
                 failed_):
        """
        :param request_id_: request_id
        :type request_id_: str
        :param values_: values
        :type values_: dict(str, list)
        :param total_count_: total_count
        :type total_count_: int
        :param errors_: errors
        :type errors_: ErrorEntry
        :param failed_: failed
        :type failed_: list(str)
        """
        self.request_id = request_id_
        self.values = values_
        self.total_count = total_count_
        self.errors = errors_
        self.failed = failed_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncValues`.
        :rtype: TagHistorianAsyncValues
        """
        request_id_ = body_dict.get('requestId')
        values_ = body_dict.get('values')
        total_count_ = body_dict.get('totalCount')
        errors_ = body_dict.get('errors')
        if errors_ is not None:
            errors_ = ErrorEntry.from_dict(errors_)
        failed_ = body_dict.get('failed')
        return cls(
            request_id_=request_id_,
            values_=values_,
            total_count_=total_count_,
            errors_=errors_,
            failed_=failed_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncValues`.
        :rtype: TagHistorianAsyncValues
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncValues` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncValues`.
        :rtype: TagHistorianAsyncValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        request_id_ = self.request_id
        values_ = self.values
        total_count_ = self.total_count
        errors_ = self.errors
        if errors_ is not None:
            errors_ = errors_.to_dict()
        failed_ = self.failed
        return {
            'requestId': request_id_,
            'values': values_,
            'totalCount': total_count_,
            'errors': errors_,
            'failed': failed_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


#
# TagIngestion service
#


class TagIngestionJournalEntry(object):
    """
    TagIngestionJournalEntry custom data type.
    """
    def __init__(self,
                 id_,
                 created_at_,
                 seen_by_,
                 update_):
        """
        :param id_: id
        :type id_: str
        :param created_at_: created_at
        :type created_at_: datetime
        :param seen_by_: seen_by
        :type seen_by_: list(str)
        :param update_: update
        :type update_: Update
        """
        self.id = id_  # pylint: disable=invalid-name
        self.created_at = created_at_
        self.seen_by = seen_by_
        self.update = update_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        id_ = body_dict.get('id')
        created_at_ = body_dict.get('createdAt')
        if created_at_ is not None and not isinstance(created_at_, datetime):
            created_at_ = to_datetime(created_at_)
        seen_by_ = body_dict.get('seenBy')
        update_ = body_dict.get('update')
        if update_ is not None:
            update_ = Update.from_dict(update_)
        return cls(
            id_=id_,
            created_at_=created_at_,
            seen_by_=seen_by_,
            update_=update_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagIngestionJournalEntry` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagIngestionJournalEntry`.
        :rtype: TagIngestionJournalEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        created_at_ = self.created_at
        if created_at_ is not None and isinstance(created_at_, datetime):
            created_at_ = from_datetime(created_at_)
        seen_by_ = self.seen_by
        update_ = self.update
        if update_ is not None:
            update_ = update_.to_dict()
        return {
            'id': id_,
            'createdAt': created_at_,
            'seenBy': seen_by_,
            'update': update_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagUpdateValuesRoutedMessage(RoutedMessage):
    """
    TagUpdateValuesRoutedMessage JSON routed message.
    """
    def __init__(self,
                 updates_):
        """
        :param updates_: updates
        :type updates_: list(Update)
        """
        self.updates = updates_
        header = MessageHeader()
        header.set_message_name('TagUpdateValuesRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagIngestion', 'TagUpdateValuesRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagUpdateValuesRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = Update.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagUpdateValuesRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagNewTagsIngestedBroadcast(BroadcastMessage):
    """
    TagNewTagsIngestedBroadcast JSON broadcast message.
    """
    def __init__(self,
                 updates_):
        """
        :param updates_: updates
        :type updates_: list(UpdateWithAggregatesAndMetadata)
        """
        self.updates = updates_
        header = MessageHeader()
        header.set_message_name('TagNewTagsIngestedBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagNewTagsIngestedBroadcast')
        header.set_routing_key(routing_key)
        super(TagNewTagsIngestedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = UpdateWithAggregatesAndMetadata.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagNewTagsIngestedBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagNewJournalsWrittenBroadcast(BroadcastMessage):
    """
    TagNewJournalsWrittenBroadcast JSON broadcast message.
    """
    def __init__(self,
                 journal_ids_):
        """
        :param journal_ids_: journal_ids
        :type journal_ids_: list(str)
        """
        self.journal_ids = journal_ids_
        header = MessageHeader()
        header.set_message_name('TagNewJournalsWrittenBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagNewJournalsWrittenBroadcast')
        header.set_routing_key(routing_key)
        super(TagNewJournalsWrittenBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        journal_ids_ = body_dict.get('journalIds')
        return cls(
            journal_ids_=journal_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagNewJournalsWrittenBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagNewJournalsWrittenBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagNewJournalsWrittenBroadcast`.
        :rtype: TagNewJournalsWrittenBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        journal_ids_ = self.journal_ids
        return {
            'journalIds': journal_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagCurrentValue service
#


class TagCvResetAggregatesRoutedMessage(RoutedMessage):
    """
    TagCvResetAggregatesRoutedMessage JSON routed message.
    """
    def __init__(self,
                 paths_):
        """
        :param paths_: paths
        :type paths_: list(str)
        """
        self.paths = paths_
        header = MessageHeader()
        header.set_message_name('TagCvResetAggregatesRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', 'TagCvResetAggregatesRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagCvResetAggregatesRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        paths_ = body_dict.get('paths')
        return cls(
            paths_=paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvResetAggregatesRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = self.paths
        return {
            'paths': paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvAggregatesResetBroadcast(BroadcastMessage):
    """
    TagCvAggregatesResetBroadcast JSON broadcast message.
    """
    def __init__(self,
                 updates_):
        """
        :param updates_: updates
        :type updates_: list(UpdateWithAggregates)
        """
        self.updates = updates_
        header = MessageHeader()
        header.set_message_name('TagCvAggregatesResetBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagCvAggregatesResetBroadcast')
        header.set_routing_key(routing_key)
        super(TagCvAggregatesResetBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = UpdateWithAggregates.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvAggregatesResetBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvQueryCurrentValuesByPathRequest(RequestMessage):
    """
    TagCvQueryCurrentValuesByPathRequest JSON request message.
    """
    def __init__(self,
                 paths_,
                 allow_stale_):
        """
        :param paths_: paths
        :type paths_: list(str)
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        """
        self.paths = paths_
        self.allow_stale = allow_stale_
        header = MessageHeader()
        header.set_message_name('TagCvQueryCurrentValuesByPathRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', 'TagCvQueryCurrentValuesByPathRequest')
        header.set_routing_key(routing_key)
        super(TagCvQueryCurrentValuesByPathRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        paths_ = body_dict.get('paths')
        allow_stale_ = body_dict.get('allowStale')
        return cls(
            paths_=paths_,
            allow_stale_=allow_stale_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = self.paths
        allow_stale_ = self.allow_stale
        return {
            'paths': paths_,
            'allowStale': allow_stale_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagCvQueryCurrentValuesByPathResponse(ResponseMessage):
    """
    TagCvQueryCurrentValuesByPathResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 values_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param values_: values
        :type values_: list(CurrentValues)
        """
        self.values = values_
        header = MessageHeader()
        header.set_message_name('TagCvQueryCurrentValuesByPathResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagCvQueryCurrentValuesByPathResponse')
            header.set_routing_key(routing_key)
        super(TagCvQueryCurrentValuesByPathResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        values_ = body_dict.get('values')
        if values_ is not None:
            new_list = []
            for item in values_:
                item = CurrentValues.from_dict(item)
                new_list.append(item)
            values_ = new_list
        return cls(
            request_message,
            values_=values_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagCvQueryCurrentValuesByPathResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        values_ = self.values
        if values_ is not None:
            new_list = []
            for item in values_:
                new_list.append(item.to_dict())
            values_ = new_list
        return {
            'values': values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagCvQueryCurrentValuesByPathResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagInfo service
#


class TagInfoCreateTagRoutedMessage(RoutedMessage):
    """
    TagInfoCreateTagRoutedMessage JSON routed message.
    """
    def __init__(self,
                 new_tag_):
        """
        :param new_tag_: new_tag
        :type new_tag_: Tag
        """
        self.new_tag = new_tag_
        header = MessageHeader()
        header.set_message_name('TagInfoCreateTagRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagInfo', 'TagInfoCreateTagRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagInfoCreateTagRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        new_tag_ = body_dict.get('newTag')
        if new_tag_ is not None:
            new_tag_ = Tag.from_dict(new_tag_)
        return cls(
            new_tag_=new_tag_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateTagRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        new_tag_ = self.new_tag
        if new_tag_ is not None:
            new_tag_ = new_tag_.to_dict()
        return {
            'newTag': new_tag_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoUpdateTagRoutedMessage(RoutedMessage):
    """
    TagInfoUpdateTagRoutedMessage JSON routed message.
    """
    def __init__(self,
                 path_,
                 keywords_,
                 properties_,
                 collect_aggregates_,
                 replace_):
        """
        :param path_: path
        :type path_: str
        :param keywords_: keywords
        :type keywords_: list(str)
        :param properties_: properties
        :type properties_: dict(str, str)
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: Aggregation
        :param replace_: replace
        :type replace_: bool
        """
        self.path = path_
        self.keywords = keywords_
        self.properties = properties_
        self.collect_aggregates = collect_aggregates_
        self.replace = replace_
        header = MessageHeader()
        header.set_message_name('TagInfoUpdateTagRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagInfo', 'TagInfoUpdateTagRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagInfoUpdateTagRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        path_ = body_dict.get('path')
        keywords_ = body_dict.get('keywords')
        properties_ = body_dict.get('properties')
        collect_aggregates_ = body_dict.get('collectAggregates')
        if collect_aggregates_ is not None:
            if isinstance(collect_aggregates_, str):
                collect_aggregates_ = Aggregation.from_string(collect_aggregates_)
            elif isinstance(collect_aggregates_, int):
                collect_aggregates_ = Aggregation(collect_aggregates_)
        replace_ = body_dict.get('replace')
        return cls(
            path_=path_,
            keywords_=keywords_,
            properties_=properties_,
            collect_aggregates_=collect_aggregates_,
            replace_=replace_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoUpdateTagRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        keywords_ = self.keywords
        properties_ = self.properties
        collect_aggregates_ = self.collect_aggregates
        if collect_aggregates_ is not None:
            collect_aggregates_ = collect_aggregates_.to_string()
        replace_ = self.replace
        return {
            'path': path_,
            'keywords': keywords_,
            'properties': properties_,
            'collectAggregates': collect_aggregates_,
            'replace': replace_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoDeleteTagsRoutedMessage(RoutedMessage):
    """
    TagInfoDeleteTagsRoutedMessage JSON routed message.
    """
    def __init__(self,
                 paths_):
        """
        :param paths_: paths
        :type paths_: list(str)
        """
        self.paths = paths_
        header = MessageHeader()
        header.set_message_name('TagInfoDeleteTagsRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagInfo', 'TagInfoDeleteTagsRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagInfoDeleteTagsRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        paths_ = body_dict.get('paths')
        return cls(
            paths_=paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoDeleteTagsRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = self.paths
        return {
            'paths': paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoDeletedTagsBroadcast(BroadcastMessage):
    """
    TagInfoDeletedTagsBroadcast JSON broadcast message.
    """
    def __init__(self,
                 tags_):
        """
        :param tags_: tags
        :type tags_: list(str)
        """
        self.tags = tags_
        header = MessageHeader()
        header.set_message_name('TagInfoDeletedTagsBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagInfoDeletedTagsBroadcast')
        header.set_routing_key(routing_key)
        super(TagInfoDeletedTagsBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        tags_ = body_dict.get('tags')
        return cls(
            tags_=tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoDeletedTagsBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = self.tags
        return {
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoTagMetadataUpdatedBroadcast(BroadcastMessage):
    """
    TagInfoTagMetadataUpdatedBroadcast JSON broadcast message.
    """
    def __init__(self,
                 updated_tag_):
        """
        :param updated_tag_: updated_tag
        :type updated_tag_: Tag
        """
        self.updated_tag = updated_tag_
        header = MessageHeader()
        header.set_message_name('TagInfoTagMetadataUpdatedBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagInfoTagMetadataUpdatedBroadcast')
        header.set_routing_key(routing_key)
        super(TagInfoTagMetadataUpdatedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        updated_tag_ = body_dict.get('updatedTag')
        if updated_tag_ is not None:
            updated_tag_ = Tag.from_dict(updated_tag_)
        return cls(
            updated_tag_=updated_tag_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoTagMetadataUpdatedBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updated_tag_ = self.updated_tag
        if updated_tag_ is not None:
            updated_tag_ = updated_tag_.to_dict()
        return {
            'updatedTag': updated_tag_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoCreateOrUpdateTagsRequest(RequestMessage):
    """
    TagInfoCreateOrUpdateTagsRequest JSON request message.
    """
    def __init__(self,
                 tags_,
                 merge_):
        """
        :param tags_: tags
        :type tags_: list(PartialTagInfo)
        :param merge_: merge
        :type merge_: bool
        """
        self.tags = tags_
        self.merge = merge_
        header = MessageHeader()
        header.set_message_name('TagInfoCreateOrUpdateTagsRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagInfo', 'TagInfoCreateOrUpdateTagsRequest')
        header.set_routing_key(routing_key)
        super(TagInfoCreateOrUpdateTagsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        tags_ = body_dict.get('tags')
        if tags_ is not None:
            new_list = []
            for item in tags_:
                item = PartialTagInfo.from_dict(item)
                new_list.append(item)
            tags_ = new_list
        merge_ = body_dict.get('merge')
        return cls(
            tags_=tags_,
            merge_=merge_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = self.tags
        if tags_ is not None:
            new_list = []
            for item in tags_:
                new_list.append(item.to_dict())
            tags_ = new_list
        merge_ = self.merge
        return {
            'tags': tags_,
            'merge': merge_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoCreateOrUpdateTagsResponse(ResponseMessage):
    """
    TagInfoCreateOrUpdateTagsResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 errors_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param errors_: errors
        :type errors_: ErrorEntry
        """
        self.errors = errors_
        header = MessageHeader()
        header.set_message_name('TagInfoCreateOrUpdateTagsResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagInfoCreateOrUpdateTagsResponse')
            header.set_routing_key(routing_key)
        super(TagInfoCreateOrUpdateTagsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        errors_ = body_dict.get('errors')
        if errors_ is not None:
            errors_ = ErrorEntry.from_dict(errors_)
        return cls(
            request_message,
            errors_=errors_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagInfoCreateOrUpdateTagsResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        errors_ = self.errors
        if errors_ is not None:
            errors_ = errors_.to_dict()
        return {
            'errors': errors_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagInfoCreateOrUpdateTagsResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoQueryTagsRequest(RequestMessage):
    """
    TagInfoQueryTagsRequest JSON request message.
    """
    def __init__(self,
                 search_paths_,
                 properties_,
                 keywords_,
                 skip_,
                 take_,
                 allow_stale_):
        """
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        :param properties_: properties
        :type properties_: dict(str, str)
        :param keywords_: keywords
        :type keywords_: list(str)
        :param skip_: skip
        :type skip_: int
        :param take_: take
        :type take_: int
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        """
        self.search_paths = search_paths_
        self.properties = properties_
        self.keywords = keywords_
        self.skip = skip_
        self.take = take_
        self.allow_stale = allow_stale_
        header = MessageHeader()
        header.set_message_name('TagInfoQueryTagsRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagInfo', 'TagInfoQueryTagsRequest')
        header.set_routing_key(routing_key)
        super(TagInfoQueryTagsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        search_paths_ = body_dict.get('searchPaths')
        properties_ = body_dict.get('properties')
        keywords_ = body_dict.get('keywords')
        skip_ = body_dict.get('skip')
        take_ = body_dict.get('take')
        allow_stale_ = body_dict.get('allowStale')
        return cls(
            search_paths_=search_paths_,
            properties_=properties_,
            keywords_=keywords_,
            skip_=skip_,
            take_=take_,
            allow_stale_=allow_stale_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoQueryTagsRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        search_paths_ = self.search_paths
        properties_ = self.properties
        keywords_ = self.keywords
        skip_ = self.skip
        take_ = self.take
        allow_stale_ = self.allow_stale
        return {
            'searchPaths': search_paths_,
            'properties': properties_,
            'keywords': keywords_,
            'skip': skip_,
            'take': take_,
            'allowStale': allow_stale_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagInfoQueryTagsResponse(ResponseMessage):
    """
    TagInfoQueryTagsResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 tags_,
                 total_count_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param tags_: tags
        :type tags_: list(Tag)
        :param total_count_: total_count
        :type total_count_: int
        """
        self.tags = tags_
        self.total_count = total_count_
        header = MessageHeader()
        header.set_message_name('TagInfoQueryTagsResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagInfoQueryTagsResponse')
            header.set_routing_key(routing_key)
        super(TagInfoQueryTagsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        tags_ = body_dict.get('tags')
        if tags_ is not None:
            new_list = []
            for item in tags_:
                item = Tag.from_dict(item)
                new_list.append(item)
            tags_ = new_list
        total_count_ = body_dict.get('totalCount')
        return cls(
            request_message,
            tags_=tags_,
            total_count_=total_count_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagInfoQueryTagsResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagInfoQueryTagsResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tags_ = self.tags
        if tags_ is not None:
            new_list = []
            for item in tags_:
                new_list.append(item.to_dict())
            tags_ = new_list
        total_count_ = self.total_count
        return {
            'tags': tags_,
            'totalCount': total_count_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagInfoQueryTagsResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagHttp service
#


class TagHttpUpdateSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpUpdateSelectionRoutedMessage JSON routed message.
    """
    def __init__(self,
                 selection_):
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.set_message_name('TagHttpUpdateSelectionRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHttp', 'TagHttpUpdateSelectionRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagHttpUpdateSelectionRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        selection_ = body_dict.get('selection')
        if selection_ is not None:
            selection_ = Selection.from_dict(selection_)
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpUpdateSelectionRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = self.selection
        if selection_ is not None:
            selection_ = selection_.to_dict()
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpDeleteSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpDeleteSelectionRoutedMessage JSON routed message.
    """
    def __init__(self,
                 id_):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.set_message_name('TagHttpDeleteSelectionRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHttp', 'TagHttpDeleteSelectionRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagHttpDeleteSelectionRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        id_ = body_dict.get('id')
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpDeleteSelectionRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionsRequest(RequestMessage):
    """
    TagHttpGetSelectionsRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHttpGetSelectionsRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHttp', 'TagHttpGetSelectionsRequest')
        header.set_routing_key(routing_key)
        super(TagHttpGetSelectionsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionsRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionsResponse(ResponseMessage):
    """
    TagHttpGetSelectionsResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 selections_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param selections_: selections
        :type selections_: list(Selection)
        """
        self.selections = selections_
        header = MessageHeader()
        header.set_message_name('TagHttpGetSelectionsResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHttpGetSelectionsResponse')
            header.set_routing_key(routing_key)
        super(TagHttpGetSelectionsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        selections_ = body_dict.get('selections')
        if selections_ is not None:
            new_list = []
            for item in selections_:
                item = Selection.from_dict(item)
                new_list.append(item)
            selections_ = new_list
        return cls(
            request_message,
            selections_=selections_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionsResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHttpGetSelectionsResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selections_ = self.selections
        if selections_ is not None:
            new_list = []
            for item in selections_:
                new_list.append(item.to_dict())
            selections_ = new_list
        return {
            'selections': selections_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHttpGetSelectionsResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionRequest(RequestMessage):
    """
    TagHttpGetSelectionRequest JSON request message.
    """
    def __init__(self,
                 id_):
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.set_message_name('TagHttpGetSelectionRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHttp', 'TagHttpGetSelectionRequest')
        header.set_routing_key(routing_key)
        super(TagHttpGetSelectionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        id_ = body_dict.get('id')
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpGetSelectionResponse(ResponseMessage):
    """
    TagHttpGetSelectionResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 selection_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.set_message_name('TagHttpGetSelectionResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHttpGetSelectionResponse')
            header.set_routing_key(routing_key)
        super(TagHttpGetSelectionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        selection_ = body_dict.get('selection')
        if selection_ is not None:
            selection_ = Selection.from_dict(selection_)
        return cls(
            request_message,
            selection_=selection_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpGetSelectionResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHttpGetSelectionResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = self.selection
        if selection_ is not None:
            selection_ = selection_.to_dict()
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHttpGetSelectionResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpCreateSelectionRequest(RequestMessage):
    """
    TagHttpCreateSelectionRequest JSON request message.
    """
    def __init__(self,
                 selection_):
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.set_message_name('TagHttpCreateSelectionRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHttp', 'TagHttpCreateSelectionRequest')
        header.set_routing_key(routing_key)
        super(TagHttpCreateSelectionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        selection_ = body_dict.get('selection')
        if selection_ is not None:
            selection_ = Selection.from_dict(selection_)
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpCreateSelectionRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        selection_ = self.selection
        if selection_ is not None:
            selection_ = selection_.to_dict()
        return {
            'selection': selection_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHttpCreateSelectionResponse(ResponseMessage):
    """
    TagHttpCreateSelectionResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 id_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.set_message_name('TagHttpCreateSelectionResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHttpCreateSelectionResponse')
            header.set_routing_key(routing_key)
        super(TagHttpCreateSelectionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        id_ = body_dict.get('id')
        return cls(
            request_message,
            id_=id_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHttpCreateSelectionResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHttpCreateSelectionResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        id_ = self.id
        return {
            'id': id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHttpCreateSelectionResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


#
# TagSubscriptionCommunicator service
#


class UpdateMode(object):  # pylint: disable=too-few-public-methods
    """
    UpdateMode normal enum.
    """
    POLL = 0
    IMMEDIATE_NOTIFICATION = 1
    BATCH = 2
    _INT_TO_STRING = {
        0: 'POLL',
        1: 'IMMEDIATE_NOTIFICATION',
        2: 'BATCH'
    }
    _STRING_TO_INT = {
        'POLL': 0,
        'IMMEDIATE_NOTIFICATION': 1,
        'BATCH': 2
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    def get_value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    def set_value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`UpdateMode` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`UpdateMode`.
        :rtype: UpdateMode
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]


class SubscriptionOptions(object):
    """
    SubscriptionOptions custom data type.
    """
    def __init__(self,
                 update_mode_,
                 updates_only_,
                 batch_interval_seconds_):
        """
        :param update_mode_: update_mode
        :type update_mode_: UpdateMode
        :param updates_only_: updates_only
        :type updates_only_: bool
        :param batch_interval_seconds_: batch_interval_seconds
        :type batch_interval_seconds_: int
        """
        self.update_mode = update_mode_
        self.updates_only = updates_only_
        self.batch_interval_seconds = batch_interval_seconds_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionOptions` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        update_mode_ = body_dict.get('updateMode')
        if update_mode_ is not None:
            if isinstance(update_mode_, str):
                update_mode_ = UpdateMode.from_string(update_mode_)
            elif isinstance(update_mode_, int):
                update_mode_ = UpdateMode(update_mode_)
        updates_only_ = body_dict.get('updatesOnly')
        batch_interval_seconds_ = body_dict.get('batchIntervalSeconds')
        return cls(
            update_mode_=update_mode_,
            updates_only_=updates_only_,
            batch_interval_seconds_=batch_interval_seconds_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionOptions` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionOptions` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        update_mode_ = self.update_mode
        if update_mode_ is not None:
            update_mode_ = update_mode_.to_string()
        updates_only_ = self.updates_only
        batch_interval_seconds_ = self.batch_interval_seconds
        return {
            'updateMode': update_mode_,
            'updatesOnly': updates_only_,
            'batchIntervalSeconds': batch_interval_seconds_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SubscriptionUpdate(object):
    """
    SubscriptionUpdate custom data type.
    """
    def __init__(self,
                 subscription_id_,
                 alias_,
                 updates_,
                 created_tags_,
                 deleted_tags_,
                 nonexistent_tags_):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param updates_: updates
        :type updates_: list(UpdateWithAggregatesAndMetadata)
        :param created_tags_: created_tags
        :type created_tags_: list(str)
        :param deleted_tags_: deleted_tags
        :type deleted_tags_: list(str)
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: list(str)
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.updates = updates_
        self.created_tags = created_tags_
        self.deleted_tags = deleted_tags_
        self.nonexistent_tags = nonexistent_tags_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        subscription_id_ = body_dict.get('subscriptionId')
        alias_ = body_dict.get('alias')
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = UpdateWithAggregatesAndMetadata.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        created_tags_ = body_dict.get('createdTags')
        deleted_tags_ = body_dict.get('deletedTags')
        nonexistent_tags_ = body_dict.get('nonexistentTags')
        return cls(
            subscription_id_=subscription_id_,
            alias_=alias_,
            updates_=updates_,
            created_tags_=created_tags_,
            deleted_tags_=deleted_tags_,
            nonexistent_tags_=nonexistent_tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SubscriptionUpdate` using a body
        of type :class:`bytes` or :class:`bytesarray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = self.subscription_id
        alias_ = self.alias
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        created_tags_ = self.created_tags
        deleted_tags_ = self.deleted_tags
        nonexistent_tags_ = self.nonexistent_tags
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'updates': updates_,
            'createdTags': created_tags_,
            'deletedTags': deleted_tags_,
            'nonexistentTags': nonexistent_tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TagSubscriptionCommunicatorPushedUpdateRoutedMessage(RoutedMessage):
    """
    TagSubscriptionCommunicatorPushedUpdateRoutedMessage JSON routed message.
    """
    def __init__(self,
                 routing_source,
                 updates_):
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param updates_: updates
        :type updates_: list(SubscriptionUpdate)
        """
        self.updates = updates_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorPushedUpdateRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorPushedUpdateRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, routing_source, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = SubscriptionUpdate.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        return cls(
            routing_source,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, routing_source, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(cls, routing_source, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        return {
            'updates': updates_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, routing_source, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscribeRequest JSON request message.
    """
    def __init__(self,
                 alias_,
                 options_,
                 tags_):
        """
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: list(str)
        """
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorSubscribeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorSubscribeRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorSubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        alias_ = body_dict.get('alias')
        options_ = body_dict.get('options')
        if options_ is not None:
            options_ = SubscriptionOptions.from_dict(options_)
        tags_ = body_dict.get('tags')
        return cls(
            alias_=alias_,
            options_=options_,
            tags_=tags_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        alias_ = self.alias
        options_ = self.options
        if options_ is not None:
            options_ = options_.to_dict()
        tags_ = self.tags
        return {
            'alias': alias_,
            'options': options_,
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscribeResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 subscription_id_,
                 alias_,
                 nonexistent_tags_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: list(str)
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.nonexistent_tags = nonexistent_tags_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorSubscribeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorSubscribeResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorSubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        subscription_id_ = body_dict.get('subscriptionId')
        alias_ = body_dict.get('alias')
        nonexistent_tags_ = body_dict.get('nonexistentTags')
        return cls(
            request_message,
            subscription_id_=subscription_id_,
            alias_=alias_,
            nonexistent_tags_=nonexistent_tags_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorSubscribeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = self.subscription_id
        alias_ = self.alias
        nonexistent_tags_ = self.nonexistent_tags
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'nonexistentTags': nonexistent_tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorSubscribeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionRequest JSON request message.
    """
    def __init__(self,
                 subscription_id_):
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetSubscriptionRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorGetSubscriptionRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetSubscriptionRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        subscription_id_ = body_dict.get('subscriptionId')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_id_ = self.subscription_id
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 valid_subscription_,
                 alias_,
                 options_,
                 tags_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param valid_subscription_: valid_subscription
        :type valid_subscription_: bool
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: list(str)
        """
        self.valid_subscription = valid_subscription_
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetSubscriptionResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetSubscriptionResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        valid_subscription_ = body_dict.get('validSubscription')
        alias_ = body_dict.get('alias')
        options_ = body_dict.get('options')
        if options_ is not None:
            options_ = SubscriptionOptions.from_dict(options_)
        tags_ = body_dict.get('tags')
        return cls(
            request_message,
            valid_subscription_=valid_subscription_,
            alias_=alias_,
            options_=options_,
            tags_=tags_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        valid_subscription_ = self.valid_subscription
        alias_ = self.alias
        options_ = self.options
        if options_ is not None:
            options_ = options_.to_dict()
        tags_ = self.tags
        return {
            'validSubscription': valid_subscription_,
            'alias': alias_,
            'options': options_,
            'tags': tags_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionsRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetSubscriptionsRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorGetSubscriptionsRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetSubscriptionsRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetSubscriptionsResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 subscription_ids_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetSubscriptionsResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionsResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetSubscriptionsResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        subscription_ids_ = body_dict.get('subscriptionIds')
        return cls(
            request_message,
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionsResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = self.subscription_ids
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorGetSubscriptionsResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorUnsubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeRequest JSON request message.
    """
    def __init__(self,
                 subscription_ids_):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorUnsubscribeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorUnsubscribeRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorUnsubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        subscription_ids_ = body_dict.get('subscriptionIds')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = self.subscription_ids
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorUnsubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 invalid_subscription_ids_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorUnsubscribeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorUnsubscribeResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorUnsubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        invalid_subscription_ids_ = body_dict.get('invalidSubscriptionIds')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorUnsubscribeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        invalid_subscription_ids_ = self.invalid_subscription_ids
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorUnsubscribeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscriptionHeartbeatRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatRequest JSON request message.
    """
    def __init__(self,
                 subscription_ids_):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorSubscriptionHeartbeatRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorSubscriptionHeartbeatRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        subscription_ids_ = body_dict.get('subscriptionIds')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = self.subscription_ids
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorSubscriptionHeartbeatResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 invalid_subscription_ids_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorSubscriptionHeartbeatResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorSubscriptionHeartbeatResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        invalid_subscription_ids_ = body_dict.get('invalidSubscriptionIds')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        invalid_subscription_ids_ = self.invalid_subscription_ids
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetUpdatesRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesRequest JSON request message.
    """
    def __init__(self,
                 subscription_ids_):
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: list(str)
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetUpdatesRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorGetUpdatesRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetUpdatesRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        subscription_ids_ = body_dict.get('subscriptionIds')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        subscription_ids_ = self.subscription_ids
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorGetUpdatesResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 updates_,
                 invalid_subscription_ids_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param updates_: updates
        :type updates_: list(SubscriptionUpdate)
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: list(str)
        """
        self.updates = updates_
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorGetUpdatesResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorGetUpdatesResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorGetUpdatesResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        updates_ = body_dict.get('updates')
        if updates_ is not None:
            new_list = []
            for item in updates_:
                item = SubscriptionUpdate.from_dict(item)
                new_list.append(item)
            updates_ = new_list
        invalid_subscription_ids_ = body_dict.get('invalidSubscriptionIds')
        return cls(
            request_message,
            updates_=updates_,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorGetUpdatesResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        updates_ = self.updates
        if updates_ is not None:
            new_list = []
            for item in updates_:
                new_list.append(item.to_dict())
            updates_ = new_list
        invalid_subscription_ids_ = self.invalid_subscription_ids
        return {
            'updates': updates_,
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorGetUpdatesResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagSubscriptionCommunicatorMessageWrapperRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperRequest binary request message.
    """
    def __init__(self,
                 body):
        """
        :param bytearray body: The binary message body
        """
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorMessageWrapperRequest')
        header.set_content_type(BINARY_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', 'TagSubscriptionCommunicatorMessageWrapperRequest')
        header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorMessageWrapperRequest, self).__init__(header, body)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        source_body = message.get_body_bytes()
        instance = cls(
            source_body
        )
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.get_body_bytes()
        return MessageBase(header, body_bytes)


class TagSubscriptionCommunicatorMessageWrapperResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperResponse binary response message.
    """
    def __init__(self,
                 request_message,
                 body):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param bytearray body: The binary message body
        """
        header = MessageHeader()
        header.set_message_name('TagSubscriptionCommunicatorMessageWrapperResponse')
        header.set_content_type(BINARY_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagSubscriptionCommunicatorMessageWrapperResponse')
            header.set_routing_key(routing_key)
        super(TagSubscriptionCommunicatorMessageWrapperResponse, self).__init__(header, body)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperResponse
        """
        source_body = message.get_body_bytes()
        instance = cls(
            message,
            source_body
        )
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagSubscriptionCommunicatorMessageWrapperResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagSubscriptionCommunicatorMessageWrapperResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.get_body_bytes()
        return MessageBase(header, body_bytes)


#
# TagHistorian service
#


class TagHistorianAsyncQueryDataRoutedMessage(RoutedMessage):
    """
    TagHistorianAsyncQueryDataRoutedMessage JSON routed message.
    """
    def __init__(self,
                 routing_source,
                 tag_historian_async_values_):
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param tag_historian_async_values_: tag_historian_async_values
        :type tag_historian_async_values_: TagHistorianAsyncValues
        """
        self.tag_historian_async_values = tag_historian_async_values_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncQueryDataRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncQueryDataRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncQueryDataRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, routing_source, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage`.
        :rtype: TagHistorianAsyncQueryDataRoutedMessage
        """
        tag_historian_async_values_ = body_dict.get('tagHistorianAsyncValues')
        if tag_historian_async_values_ is not None:
            tag_historian_async_values_ = TagHistorianAsyncValues.from_dict(tag_historian_async_values_)
        return cls(
            routing_source,
            tag_historian_async_values_=tag_historian_async_values_
        )

    @classmethod
    def from_json(cls, routing_source, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage`.
        :rtype: TagHistorianAsyncQueryDataRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(cls, routing_source, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncQueryDataRoutedMessage`.
        :rtype: TagHistorianAsyncQueryDataRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source, message):
        """
        Create a new instance of :class`TagHistorianAsyncQueryDataRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncQueryDataRoutedMessage`.
        :rtype: TagHistorianAsyncQueryDataRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_historian_async_values_ = self.tag_historian_async_values
        if tag_historian_async_values_ is not None:
            tag_historian_async_values_ = tag_historian_async_values_.to_dict()
        return {
            'tagHistorianAsyncValues': tag_historian_async_values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, routing_source, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncQueryDataRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncQueryCompleteRoutedMessage(RoutedMessage):
    """
    TagHistorianAsyncQueryCompleteRoutedMessage JSON routed message.
    """
    def __init__(self,
                 routing_source,
                 query_jobs_):
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param query_jobs_: query_jobs
        :type query_jobs_: list(HistoricalTagAsyncQueryJob)
        """
        self.query_jobs = query_jobs_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncQueryCompleteRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncQueryCompleteRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncQueryCompleteRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, routing_source, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage`.
        :rtype: TagHistorianAsyncQueryCompleteRoutedMessage
        """
        query_jobs_ = body_dict.get('queryJobs')
        if query_jobs_ is not None:
            new_list = []
            for item in query_jobs_:
                item = HistoricalTagAsyncQueryJob.from_dict(item)
                new_list.append(item)
            query_jobs_ = new_list
        return cls(
            routing_source,
            query_jobs_=query_jobs_
        )

    @classmethod
    def from_json(cls, routing_source, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage`.
        :rtype: TagHistorianAsyncQueryCompleteRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(cls, routing_source, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncQueryCompleteRoutedMessage`.
        :rtype: TagHistorianAsyncQueryCompleteRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source, message):
        """
        Create a new instance of :class`TagHistorianAsyncQueryCompleteRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncQueryCompleteRoutedMessage`.
        :rtype: TagHistorianAsyncQueryCompleteRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        query_jobs_ = self.query_jobs
        if query_jobs_ is not None:
            new_list = []
            for item in query_jobs_:
                new_list.append(item.to_dict())
            query_jobs_ = new_list
        return {
            'queryJobs': query_jobs_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, routing_source, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncQueryCompleteRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncValuesProcessedRoutedMessage(RoutedMessage):
    """
    TagHistorianAsyncValuesProcessedRoutedMessage JSON routed message.
    """
    def __init__(self,
                 routing_source,
                 values_):
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param values_: values
        :type values_: list(HistoricalValue)
        """
        self.values = values_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncValuesProcessedRoutedMessage')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncValuesProcessedRoutedMessage')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncValuesProcessedRoutedMessage, self).__init__(header, None)

    @classmethod
    def from_dict(cls, routing_source, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage`.
        :rtype: TagHistorianAsyncValuesProcessedRoutedMessage
        """
        values_ = body_dict.get('values')
        if values_ is not None:
            new_list = []
            for item in values_:
                item = HistoricalValue.from_dict(item)
                new_list.append(item)
            values_ = new_list
        return cls(
            routing_source,
            values_=values_
        )

    @classmethod
    def from_json(cls, routing_source, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage`.
        :rtype: TagHistorianAsyncValuesProcessedRoutedMessage
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(cls, routing_source, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncValuesProcessedRoutedMessage`.
        :rtype: TagHistorianAsyncValuesProcessedRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source, message):
        """
        Create a new instance of :class`TagHistorianAsyncValuesProcessedRoutedMessage` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncValuesProcessedRoutedMessage`.
        :rtype: TagHistorianAsyncValuesProcessedRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        values_ = self.values
        if values_ is not None:
            new_list = []
            for item in values_:
                new_list.append(item.to_dict())
            values_ = new_list
        return {
            'values': values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, routing_source, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: niskyline.messagebus.message_base.MessageBase
        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(routing_source.get_reply_to(), 'TagHistorianAsyncValuesProcessedRoutedMessage')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianValuesProcessedBroadcast(BroadcastMessage):
    """
    TagHistorianValuesProcessedBroadcast JSON broadcast message.
    """
    def __init__(self,
                 values_):
        """
        :param values_: values
        :type values_: list(HistoricalValue)
        """
        self.values = values_
        header = MessageHeader()
        header.set_message_name('TagHistorianValuesProcessedBroadcast')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key(None, 'TagHistorianValuesProcessedBroadcast')
        header.set_routing_key(routing_key)
        super(TagHistorianValuesProcessedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianValuesProcessedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianValuesProcessedBroadcast`.
        :rtype: TagHistorianValuesProcessedBroadcast
        """
        values_ = body_dict.get('values')
        if values_ is not None:
            new_list = []
            for item in values_:
                item = HistoricalValue.from_dict(item)
                new_list.append(item)
            values_ = new_list
        return cls(
            values_=values_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianValuesProcessedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianValuesProcessedBroadcast`.
        :rtype: TagHistorianValuesProcessedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianValuesProcessedBroadcast` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianValuesProcessedBroadcast`.
        :rtype: TagHistorianValuesProcessedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianValuesProcessedBroadcast` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianValuesProcessedBroadcast`.
        :rtype: TagHistorianValuesProcessedBroadcast
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        values_ = self.values
        if values_ is not None:
            new_list = []
            for item in values_:
                new_list.append(item.to_dict())
            values_ = new_list
        return {
            'values': values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianQueryRequest(RequestMessage):
    """
    TagHistorianQueryRequest JSON request message.
    """
    def __init__(self,
                 paths_,
                 start_time_,
                 end_time_,
                 skip_,
                 take_,
                 decimation_,
                 sort_order_):
        """
        :param paths_: paths
        :type paths_: list(str)
        :param start_time_: start_time
        :type start_time_: datetime
        :param end_time_: end_time
        :type end_time_: datetime
        :param skip_: skip
        :type skip_: int
        :param take_: take
        :type take_: int
        :param decimation_: decimation
        :type decimation_: int
        :param sort_order_: sort_order
        :type sort_order_: SortOrder
        """
        self.paths = paths_
        self.start_time = start_time_
        self.end_time = end_time_
        self.skip = skip_
        self.take = take_
        self.decimation = decimation_
        self.sort_order = sort_order_
        header = MessageHeader()
        header.set_message_name('TagHistorianQueryRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianQueryRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianQueryRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianQueryRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianQueryRequest`.
        :rtype: TagHistorianQueryRequest
        """
        paths_ = body_dict.get('paths')
        start_time_ = body_dict.get('startTime')
        if start_time_ is not None and not isinstance(start_time_, datetime):
            start_time_ = to_datetime(start_time_)
        end_time_ = body_dict.get('endTime')
        if end_time_ is not None and not isinstance(end_time_, datetime):
            end_time_ = to_datetime(end_time_)
        skip_ = body_dict.get('skip')
        take_ = body_dict.get('take')
        decimation_ = body_dict.get('decimation')
        sort_order_ = body_dict.get('sortOrder')
        if sort_order_ is not None:
            if isinstance(sort_order_, str):
                sort_order_ = SortOrder.from_string(sort_order_)
            elif isinstance(sort_order_, int):
                sort_order_ = SortOrder(sort_order_)
        return cls(
            paths_=paths_,
            start_time_=start_time_,
            end_time_=end_time_,
            skip_=skip_,
            take_=take_,
            decimation_=decimation_,
            sort_order_=sort_order_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianQueryRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianQueryRequest`.
        :rtype: TagHistorianQueryRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianQueryRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianQueryRequest`.
        :rtype: TagHistorianQueryRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianQueryRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianQueryRequest`.
        :rtype: TagHistorianQueryRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        paths_ = self.paths
        start_time_ = self.start_time
        if start_time_ is not None and isinstance(start_time_, datetime):
            start_time_ = from_datetime(start_time_)
        end_time_ = self.end_time
        if end_time_ is not None and isinstance(end_time_, datetime):
            end_time_ = from_datetime(end_time_)
        skip_ = self.skip
        take_ = self.take
        decimation_ = self.decimation
        sort_order_ = self.sort_order
        if sort_order_ is not None:
            sort_order_ = sort_order_.to_string()
        return {
            'paths': paths_,
            'startTime': start_time_,
            'endTime': end_time_,
            'skip': skip_,
            'take': take_,
            'decimation': decimation_,
            'sortOrder': sort_order_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianQueryResponse(ResponseMessage):
    """
    TagHistorianQueryResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 tag_historian_values_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param tag_historian_values_: tag_historian_values
        :type tag_historian_values_: TagHistorianValues
        """
        self.tag_historian_values = tag_historian_values_
        header = MessageHeader()
        header.set_message_name('TagHistorianQueryResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianQueryResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianQueryResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHistorianQueryResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianQueryResponse`.
        :rtype: TagHistorianQueryResponse
        """
        tag_historian_values_ = body_dict.get('tagHistorianValues')
        if tag_historian_values_ is not None:
            tag_historian_values_ = TagHistorianValues.from_dict(tag_historian_values_)
        return cls(
            request_message,
            tag_historian_values_=tag_historian_values_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianQueryResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianQueryResponse`.
        :rtype: TagHistorianQueryResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianQueryResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianQueryResponse`.
        :rtype: TagHistorianQueryResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianQueryResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianQueryResponse`.
        :rtype: TagHistorianQueryResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianQueryResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        tag_historian_values_ = self.tag_historian_values
        if tag_historian_values_ is not None:
            tag_historian_values_ = tag_historian_values_.to_dict()
        return {
            'tagHistorianValues': tag_historian_values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianQueryResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncQueryRequest(RequestMessage):
    """
    TagHistorianAsyncQueryRequest JSON request message.
    """
    def __init__(self,
                 queries_):
        """
        :param queries_: queries
        :type queries_: list(HistoricalTagQuery)
        """
        self.queries = queries_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncQueryRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianAsyncQueryRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncQueryRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncQueryRequest`.
        :rtype: TagHistorianAsyncQueryRequest
        """
        queries_ = body_dict.get('queries')
        if queries_ is not None:
            new_list = []
            for item in queries_:
                item = HistoricalTagQuery.from_dict(item)
                new_list.append(item)
            queries_ = new_list
        return cls(
            queries_=queries_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncQueryRequest`.
        :rtype: TagHistorianAsyncQueryRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncQueryRequest`.
        :rtype: TagHistorianAsyncQueryRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncQueryRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncQueryRequest`.
        :rtype: TagHistorianAsyncQueryRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        queries_ = self.queries
        if queries_ is not None:
            new_list = []
            for item in queries_:
                new_list.append(item.to_dict())
            queries_ = new_list
        return {
            'queries': queries_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncQueryResponse(ResponseMessage):
    """
    TagHistorianAsyncQueryResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 query_jobs_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param query_jobs_: query_jobs
        :type query_jobs_: list(HistoricalTagAsyncQueryJob)
        """
        self.query_jobs = query_jobs_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncQueryResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianAsyncQueryResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianAsyncQueryResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncQueryResponse`.
        :rtype: TagHistorianAsyncQueryResponse
        """
        query_jobs_ = body_dict.get('queryJobs')
        if query_jobs_ is not None:
            new_list = []
            for item in query_jobs_:
                item = HistoricalTagAsyncQueryJob.from_dict(item)
                new_list.append(item)
            query_jobs_ = new_list
        return cls(
            request_message,
            query_jobs_=query_jobs_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncQueryResponse`.
        :rtype: TagHistorianAsyncQueryResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncQueryResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncQueryResponse`.
        :rtype: TagHistorianAsyncQueryResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncQueryResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncQueryResponse`.
        :rtype: TagHistorianAsyncQueryResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianAsyncQueryResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        query_jobs_ = self.query_jobs
        if query_jobs_ is not None:
            new_list = []
            for item in query_jobs_:
                new_list.append(item.to_dict())
            query_jobs_ = new_list
        return {
            'queryJobs': query_jobs_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianAsyncQueryResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncSubscribeRequest(RequestMessage):
    """
    TagHistorianAsyncSubscribeRequest JSON request message.
    """
    def __init__(self,
                 search_paths_):
        """
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        """
        self.search_paths = search_paths_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncSubscribeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianAsyncSubscribeRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncSubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncSubscribeRequest`.
        :rtype: TagHistorianAsyncSubscribeRequest
        """
        search_paths_ = body_dict.get('searchPaths')
        return cls(
            search_paths_=search_paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncSubscribeRequest`.
        :rtype: TagHistorianAsyncSubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncSubscribeRequest`.
        :rtype: TagHistorianAsyncSubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncSubscribeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncSubscribeRequest`.
        :rtype: TagHistorianAsyncSubscribeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        search_paths_ = self.search_paths
        return {
            'searchPaths': search_paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncSubscribeResponse(ResponseMessage):
    """
    TagHistorianAsyncSubscribeResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncSubscribeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianAsyncSubscribeResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianAsyncSubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncSubscribeResponse`.
        :rtype: TagHistorianAsyncSubscribeResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncSubscribeResponse`.
        :rtype: TagHistorianAsyncSubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncSubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncSubscribeResponse`.
        :rtype: TagHistorianAsyncSubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncSubscribeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncSubscribeResponse`.
        :rtype: TagHistorianAsyncSubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianAsyncSubscribeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianAsyncSubscribeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncUnsubscribeRequest(RequestMessage):
    """
    TagHistorianAsyncUnsubscribeRequest JSON request message.
    """
    def __init__(self,
                 search_paths_):
        """
        :param search_paths_: search_paths
        :type search_paths_: list(str)
        """
        self.search_paths = search_paths_
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncUnsubscribeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianAsyncUnsubscribeRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianAsyncUnsubscribeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeRequest`.
        :rtype: TagHistorianAsyncUnsubscribeRequest
        """
        search_paths_ = body_dict.get('searchPaths')
        return cls(
            search_paths_=search_paths_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeRequest`.
        :rtype: TagHistorianAsyncUnsubscribeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeRequest`.
        :rtype: TagHistorianAsyncUnsubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncUnsubscribeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncUnsubscribeRequest`.
        :rtype: TagHistorianAsyncUnsubscribeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        search_paths_ = self.search_paths
        return {
            'searchPaths': search_paths_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianAsyncUnsubscribeResponse(ResponseMessage):
    """
    TagHistorianAsyncUnsubscribeResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianAsyncUnsubscribeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianAsyncUnsubscribeResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianAsyncUnsubscribeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeResponse`.
        :rtype: TagHistorianAsyncUnsubscribeResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeResponse`.
        :rtype: TagHistorianAsyncUnsubscribeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianAsyncUnsubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianAsyncUnsubscribeResponse`.
        :rtype: TagHistorianAsyncUnsubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianAsyncUnsubscribeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianAsyncUnsubscribeResponse`.
        :rtype: TagHistorianAsyncUnsubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianAsyncUnsubscribeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianAsyncUnsubscribeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianUpdateValuesRequest(RequestMessage):
    """
    TagHistorianUpdateValuesRequest JSON request message.
    """
    def __init__(self,
                 path_,
                 values_):
        """
        :param path_: path
        :type path_: str
        :param values_: values
        :type values_: list(HistoricalValueUpdate)
        """
        self.path = path_
        self.values = values_
        header = MessageHeader()
        header.set_message_name('TagHistorianUpdateValuesRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianUpdateValuesRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianUpdateValuesRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianUpdateValuesRequest`.
        :rtype: TagHistorianUpdateValuesRequest
        """
        path_ = body_dict.get('path')
        values_ = body_dict.get('values')
        if values_ is not None:
            new_list = []
            for item in values_:
                item = HistoricalValueUpdate.from_dict(item)
                new_list.append(item)
            values_ = new_list
        return cls(
            path_=path_,
            values_=values_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianUpdateValuesRequest`.
        :rtype: TagHistorianUpdateValuesRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianUpdateValuesRequest`.
        :rtype: TagHistorianUpdateValuesRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianUpdateValuesRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianUpdateValuesRequest`.
        :rtype: TagHistorianUpdateValuesRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        values_ = self.values
        if values_ is not None:
            new_list = []
            for item in values_:
                new_list.append(item.to_dict())
            values_ = new_list
        return {
            'path': path_,
            'values': values_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianUpdateValuesResponse(ResponseMessage):
    """
    TagHistorianUpdateValuesResponse JSON response message.
    """
    def __init__(self,
                 request_message,
                 errors_):
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param errors_: errors
        :type errors_: ErrorEntry
        """
        self.errors = errors_
        header = MessageHeader()
        header.set_message_name('TagHistorianUpdateValuesResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianUpdateValuesResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianUpdateValuesResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianUpdateValuesResponse`.
        :rtype: TagHistorianUpdateValuesResponse
        """
        errors_ = body_dict.get('errors')
        if errors_ is not None:
            errors_ = ErrorEntry.from_dict(errors_)
        return cls(
            request_message,
            errors_=errors_
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianUpdateValuesResponse`.
        :rtype: TagHistorianUpdateValuesResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianUpdateValuesResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianUpdateValuesResponse`.
        :rtype: TagHistorianUpdateValuesResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianUpdateValuesResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianUpdateValuesResponse`.
        :rtype: TagHistorianUpdateValuesResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianUpdateValuesResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        errors_ = self.errors
        if errors_ is not None:
            errors_ = errors_.to_dict()
        return {
            'errors': errors_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianUpdateValuesResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianDeleteValuesByIdRequest(RequestMessage):
    """
    TagHistorianDeleteValuesByIdRequest JSON request message.
    """
    def __init__(self,
                 path_,
                 ids_):
        """
        :param path_: path
        :type path_: str
        :param ids_: ids
        :type ids_: list(str)
        """
        self.path = path_
        self.ids = ids_
        header = MessageHeader()
        header.set_message_name('TagHistorianDeleteValuesByIdRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianDeleteValuesByIdRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianDeleteValuesByIdRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdRequest`.
        :rtype: TagHistorianDeleteValuesByIdRequest
        """
        path_ = body_dict.get('path')
        ids_ = body_dict.get('ids')
        return cls(
            path_=path_,
            ids_=ids_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdRequest`.
        :rtype: TagHistorianDeleteValuesByIdRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdRequest`.
        :rtype: TagHistorianDeleteValuesByIdRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianDeleteValuesByIdRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianDeleteValuesByIdRequest`.
        :rtype: TagHistorianDeleteValuesByIdRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        path_ = self.path
        ids_ = self.ids
        return {
            'path': path_,
            'ids': ids_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianDeleteValuesByIdResponse(ResponseMessage):
    """
    TagHistorianDeleteValuesByIdResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianDeleteValuesByIdResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianDeleteValuesByIdResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianDeleteValuesByIdResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdResponse`.
        :rtype: TagHistorianDeleteValuesByIdResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdResponse`.
        :rtype: TagHistorianDeleteValuesByIdResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByIdResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianDeleteValuesByIdResponse`.
        :rtype: TagHistorianDeleteValuesByIdResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianDeleteValuesByIdResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianDeleteValuesByIdResponse`.
        :rtype: TagHistorianDeleteValuesByIdResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianDeleteValuesByIdResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianDeleteValuesByIdResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianDeleteValuesByRangeRequest(RequestMessage):
    """
    TagHistorianDeleteValuesByRangeRequest JSON request message.
    """
    def __init__(self,
                 ranges_):
        """
        :param ranges_: ranges
        :type ranges_: list(HistoricalTagQueryRange)
        """
        self.ranges = ranges_
        header = MessageHeader()
        header.set_message_name('TagHistorianDeleteValuesByRangeRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianDeleteValuesByRangeRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianDeleteValuesByRangeRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeRequest`.
        :rtype: TagHistorianDeleteValuesByRangeRequest
        """
        ranges_ = body_dict.get('ranges')
        if ranges_ is not None:
            new_list = []
            for item in ranges_:
                item = HistoricalTagQueryRange.from_dict(item)
                new_list.append(item)
            ranges_ = new_list
        return cls(
            ranges_=ranges_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeRequest`.
        :rtype: TagHistorianDeleteValuesByRangeRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeRequest`.
        :rtype: TagHistorianDeleteValuesByRangeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianDeleteValuesByRangeRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianDeleteValuesByRangeRequest`.
        :rtype: TagHistorianDeleteValuesByRangeRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        ranges_ = self.ranges
        if ranges_ is not None:
            new_list = []
            for item in ranges_:
                new_list.append(item.to_dict())
            ranges_ = new_list
        return {
            'ranges': ranges_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianDeleteValuesByRangeResponse(ResponseMessage):
    """
    TagHistorianDeleteValuesByRangeResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianDeleteValuesByRangeResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianDeleteValuesByRangeResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianDeleteValuesByRangeResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeResponse`.
        :rtype: TagHistorianDeleteValuesByRangeResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeResponse`.
        :rtype: TagHistorianDeleteValuesByRangeResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianDeleteValuesByRangeResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianDeleteValuesByRangeResponse`.
        :rtype: TagHistorianDeleteValuesByRangeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianDeleteValuesByRangeResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianDeleteValuesByRangeResponse`.
        :rtype: TagHistorianDeleteValuesByRangeResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianDeleteValuesByRangeResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianDeleteValuesByRangeResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianFlushValuesRequest(RequestMessage):
    """
    TagHistorianFlushValuesRequest JSON request message.
    """
    def __init__(self):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianFlushValuesRequest')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        routing_key = MessageHeader.generate_routing_key('TagHistorian', 'TagHistorianFlushValuesRequest')
        header.set_routing_key(routing_key)
        super(TagHistorianFlushValuesRequest, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianFlushValuesRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianFlushValuesRequest`.
        :rtype: TagHistorianFlushValuesRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TagHistorianFlushValuesRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianFlushValuesRequest`.
        :rtype: TagHistorianFlushValuesRequest
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TagHistorianFlushValuesRequest` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianFlushValuesRequest`.
        :rtype: TagHistorianFlushValuesRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianFlushValuesRequest` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianFlushValuesRequest`.
        :rtype: TagHistorianFlushValuesRequest
        """
        instance = cls.from_body_bytes(message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class TagHistorianFlushValuesResponse(ResponseMessage):
    """
    TagHistorianFlushValuesResponse JSON response message.
    """
    def __init__(self,
                 request_message):
        """
        """
        header = MessageHeader()
        header.set_message_name('TagHistorianFlushValuesResponse')
        header.set_content_type(JSON_MESSAGE_CONTENT_TYPE)
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.set_correlation_id(request_message.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_message.get_reply_to(), 'TagHistorianFlushValuesResponse')
            header.set_routing_key(routing_key)
        super(TagHistorianFlushValuesResponse, self).__init__(header, None)

    @classmethod
    def from_dict(cls, request_message, body_dict):  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHistorianFlushValuesResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`TagHistorianFlushValuesResponse`.
        :rtype: TagHistorianFlushValuesResponse
        """
        return cls(
            request_message
        )

    @classmethod
    def from_json(cls, request_message, body_json):
        """
        Create a new instance of :class:`TagHistorianFlushValuesResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHistorianFlushValuesResponse`.
        :rtype: TagHistorianFlushValuesResponse
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(cls, request_message, body_bytes):
        """
        Create a new instance of :class:`TagHistorianFlushValuesResponse` using a body
        of type :class:`bytes` or :class:`bytesarray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytesarray
        :return: A new instance of :class:`TagHistorianFlushValuesResponse`.
        :rtype: TagHistorianFlushValuesResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`TagHistorianFlushValuesResponse` using a
        :class:`niskyline.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: niskyline.messagebus.message_base.MessageBase
        :return: A new instance of :class`TagHistorianFlushValuesResponse`.
        :rtype: TagHistorianFlushValuesResponse
        """
        instance = cls.from_body_bytes(message, message.get_body_bytes())
        instance.set_correlation_id(message.get_correlation_id())
        instance.set_reply_to(message.get_reply_to())
        routing_key = MessageHeader.generate_routing_key(message.get_reply_to(), 'TagHistorianFlushValuesResponse')
        instance.set_routing_key(routing_key)
        return instance

    def to_dict(self):  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        return {
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`niskyline.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: niskyline.messagebus.message_base.MessageBase or None
        :return: A :class:`niskyline.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: niskyline.messagebus.message_base.MessageBase
        """
        header = self.get_header()
        if request_message:
            request_header = request_message.get_header()
            header.set_correlation_id(request_header.get_correlation_id())
            routing_key = MessageHeader.generate_routing_key(request_header.get_reply_to(), 'TagHistorianFlushValuesResponse')
            header.set_routing_key(routing_key)
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    def get_body_bytes(self):
        """
        Returns a :class:`bytesarray` body representing the data in this object.

        :return: A :class:`bytesarray` body representing the data in this object.
        :rtype: bytesarray
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body
